void FighterInit(Fighter *f)
{
	ObjectCreate(&(f->obj), 12,12,6);
	ObjectCreate(&(f->robj), 12,12,6);
 	f->ax = ebasex; f->ay = fdbl(2); f->az = ebasez;
 	f->vx = fdbl(0); f->vy = 50; f->vz = fdbl(-1); 
    f->Kurs=fdbl(180); f->Tang=0; f->Kren=0;      f->H=4;
    f->state = 0;  f->visible=0; f->crc = 0x12345678; f->rnum = 6; f->tgn=-1; f->type = 0;
}

void FighterFree(Fighter *f)
{
 	ObjectFree(&(f->obj));
 	ObjectFree(&(f->robj));
}

void FighterDraw(Fighter *f, Int16 n)
{
	Int32 x, y;
 	Dot ct;
  	dbl v1[3], v2[3], rview=fdbl(1000);
   	Int32 tt;
  	ct.ax = f->ax; ct.ay = f->ay; ct.az = f->az; ct.df = 1;

    f->visible=0;
 
 	if (Abs(MX - f->ax) > fdbl(4000) || Abs(MZ - f->az) > fdbl(4000)) return;
   
   	DotCalc(&ct, 1);
    if (ct.rz <= 0) return;
    if (ct.cx <0) return;
    if (ct.cy <0) return;
    if (ct.cx >159) return;
    if (ct.cy >159) return;
    
    if (f->type==1) rview=fdbl(1500);
    
    if (ct.rz>rview) {
        if (Abs(Abs(cKren)-fdbl(90))<fdbl(45)) {
            WDrawPixel(ct.cx, ct.cy);
            WDrawPixel(ct.cx, ct.cy+1);
        } else
         	DrawHline(ct.cy, ct.cx, ct.cx+1, clrFighter);
          
        if ((tt = Abs(ct.cx-80) + Abs(ct.cy-65)) <= 60)
        	if (Abs(f->ax - mx)<fdbl(2000) && Abs(f->az - mz)<fdbl(2000))
		        if (tt < ltd) {
        		    ltn = n; ltd = tt;
		        }
        if (n == ltn) {
            ltx = ct.cx; lty = ct.cy; 
        }
        return;
    }
    
    if (f->crc != (f->Kurs ^ f->Tang ^ f->Kren)) {
	    Int32 mkrs=fint(-f->Kurs)%360, mtng=fint(-f->Tang)%360, mkrn=fint(-f->Kren)%360;
	    if (mkrs<0) mkrs+=360;
    	if (mkrn<0) mkrn+=360;
	    if (mtng<0) mtng+=360;
    
     	for(y=0;y<3;y++)
         for(x=0;x<3;x++)
          Msb[y*3+x]=fdbl((x==y));
	    MatrCopy(Msb, Rt);
	    Rt[0*3+0]=cosa[mkrn];
	    Rt[0*3+1]=-sina[mkrn];
	    Rt[1*3+0]=sina[mkrn];
	    Rt[1*3+1]=cosa[mkrn];
	
	    Msb[0*3+0]=cosa[mkrs];
	    Msb[0*3+2]=-sina[mkrs];
	    Msb[2*3+0]=sina[mkrs];
	    Msb[2*3+2]=cosa[mkrs];
	    MatrMul(Msb, Rt);
     
     	for(x=0;x<airplane.ndots;x++) {
          if (f->type==0) {
	          v1[0] = airplane.dots[x].ax;
    	      v1[1] = airplane.dots[x].ay;
        	  v1[2] = airplane.dots[x].az;
          } else
          if (f->type==1) {
	          v1[0] = bigplane.dots[x].ax;
    	      v1[1] = bigplane.dots[x].ay;
        	  v1[2] = bigplane.dots[x].az;
          } 
          
          MatrVect(Rt, v1, v2);
          f->robj.dots[x].ax = v2[0];
          f->robj.dots[x].ay = v2[1];
          f->robj.dots[x].az = v2[2];
        }
        f->crc = f->Kurs ^ f->Tang ^ f->Kren;
    }
        
    for(x=0;x<f->obj.ndots;x++) {
        f->obj.dots[x].ax = f->robj.dots[x].ax + f->ax;
        f->obj.dots[x].ay = f->robj.dots[x].ay + f->ay;
        f->obj.dots[x].az = f->robj.dots[x].az + f->az;
    }
    
	ObjectDraw(&(f->obj));
    f->visible=1;
    if (f->obj.dots[6].df!=1) return; // possibly not seen
 	x = f->obj.dots[6].cx; 	y = f->obj.dots[6].cy;
  	if (x>=0 && x<159 && y>=0 && y<130) {
        if ((tt = Abs(x-80) + Abs(y-65)) <= 60)
	        if (tt < ltd) {
       		    ltn = n; ltd = tt;
	        }
	    if (n == ltn) {
    	    ltx = x; lty = y; 
	    }
    }
}

void DrawFighters()
{
 	Int16 x;
    UInt8 old_col;

  	ltd=100; ltx=lty=-100;
    old_col = WSetForeColor(clrFighter);
  	for(x=0;x<16;x++)
   		if (fgt[x].state>0)
     		FighterDraw(&(fgt[x]), x);
    WSetForeColor(old_col);
    if (weapon==1 && ltx>0 && !viewstate) {
        WinDrawLine(ltx-5,lty-5,ltx+5,lty-5);
        WinDrawLine(ltx+5,lty-5,ltx+5,lty+5);
        WinDrawLine(ltx-5,lty+5,ltx+5,lty+5);
        WinDrawLine(ltx-5,lty-5,ltx-5,lty+5);
    }
}

void FighterFlyTo(Fighter *f)
{
	dbl dx,dz, r, idx,idz, spr, vpr;
    Int32 ks;

	if (Abs(f->ax - f->tx)<fdbl(1000) && Abs(f->az - f->tz)<fdbl(1000)) { //got there
     	switch(f->role) {
          case 0: f->state=4; break;
          case 1: f->state=3; break;
          case 2: f->state=5; break;
          case 3: f->state=3; break;
          case 4: f->state=6; break;
          case 5: f->state=7; f->timetogo=TimGetTicks()+200; break;
        }
        return;
    }
    f->vy = 0;    
    
    dx = f->tx - f->ax;    dz = f->tz - f->az;
    idx = fint(dx); idz = fint(dz);
    r = isqrt( idx*idx + idz*idz); r=fdbl(r);
    dx = fdiv(dx, r); dz = fdiv(dz, r);
    
    spr = fmul(dx,f->vx) + fmul(dz,f->vz); //scalar product
    if (spr< 240) { //need to turn
    	vpr = fmul(dx, f->vz) - fmul(dz, f->vx); // vector product
     	if (vpr >0) {// turn rite ?
      		f->Kurs += fdbl(10);
        	f->Kren = fdbl(45);
        } else {
      		f->Kurs -= fdbl(10);
        	f->Kren = fdbl(-45);
        }
    } else {
        f->Kren = 0;
    }

   	ks = fint(f->Kurs)%360;
	if (ks<0) ks+=360;
   	f->vx = sina[ks];
   	f->vz = cosa[ks];
    if (fint(f->ay)/50 < f->H) f->vy = 50;
    if (fint(f->ay)/50 > f->H) f->vy = -50;
}

void FighterPatrol(Fighter *f)
{
	dbl dx,dz, r, idx,idz, spr, vpr;
    Int32 ks;

	if (Abs(f->ax - mx)<fdbl(3000) && Abs(f->az - mz)<fdbl(3000)) { //player near
 		f->state=4;
        return;
    }
    dx = f->tx - f->ax;    dz = f->tz - f->az;
    idx = fint(dx); idz = fint(dz);
    r = isqrt(idx*idx + idz*idz); if (r<1) r=1; r=fdbl(r);
    dx = fdiv(dx, r); dz = fdiv(dz, r);
    
    spr = fmul(dx,f->vx) + fmul(dz,f->vz); //scalar product
    if (spr< 0) { //need to turn
    	vpr = fmul(dx, f->vz) - fmul(dz, f->vx); // vector product
     	if (vpr >0) {// turn rite ?
      		f->Kurs += fdbl(10);
        	f->Kren = fdbl(45);
        } else {
      		f->Kurs -= fdbl(10);
        	f->Kren = fdbl(-45);
        }
    } else {
        f->Kren = 0;
    }

   	ks = fint(f->Kurs)%360;
	if (ks<0) ks+=360;
   	f->vx = sina[ks];
   	f->vz = cosa[ks];
    if (fint(f->ay)/50 < f->H) f->vy = 50;
    if (fint(f->ay)/50 > f->H) f->vy = -50;
}

void FighterAttackGround(Fighter *f)
{
	Int16 i;
	i = RocketSend(1, f->tgn, f->ax, f->ay - fdbl(5), f->az);
 	if (i>=0) {
      	rkt[i].tx = f->tx; rkt[i].ty = f->ty; rkt[i].tz = f->tz; 
       	f->state = 4;
    }
}

void FighterAttackUser(Fighter *f)
{
 	UInt32 t;
	dbl dx,dz, r, idx,idz, spr, vpr;
    Int32 ks;
  
  	if (f->rnum<=0) {
       f->tx = ebasex; f->tz = ebasez;
       f->state=2; f->role=1;
       return;
    }

	//else look at user  
    dx = mx - f->ax;    dz = mz - f->az;
    idx = fint(dx); idz = fint(dz);
    r = isqrt( idx*idx + idz*idz); r=fdbl(r);
    dx = fdiv(dx, r); dz = fdiv(dz, r);
    
    spr = fmul(dx,f->vx) + fmul(dz,f->vz); //scalar product
    if (spr< 240) { //need to turn
    	vpr = fmul(dx, f->vz) - fmul(dz, f->vx); // vector product
     	if (vpr >0) {// turn rite ?
      		f->Kurs += fdbl(10);
        	f->Kren = fdbl(45);
        } else {
      		f->Kurs -= fdbl(10);
        	f->Kren = fdbl(-45);
        }
    } else {
        f->Kren = 0;
    }

   	ks = fint(f->Kurs)%360;
	if (ks<0) ks+=360;
   	f->vx = sina[ks];
   	f->vz = cosa[ks];
    if (fint(f->ay)/50 < f->H) f->vy = 50;
    if (fint(f->ay)/50 > f->H) f->vy = -50;
   	
 	if (Abs(f->ax - mx)<fdbl(2000) && Abs(f->az - mz)<fdbl(2000) && spr>=200) { //player in range of fire
  		RocketSend(3,-1, f->ax, f->ay - fdbl(5), f->az); // fire
    	f->rnum--;
    	t = TimGetTicks();
     	dx = bitrand(t*0xBE) % fdbl(3000); dz = bitrand(t*0xDEAD) % fdbl(3000);
      	f->tx = f->ax + dx; f->tz = f->az + dz; f->ty = fdbl(100);
       	f->role = 0; f->state = 2;						// and step on side
		return;      	
 	}
}

void FighterAttackPlane(Fighter *f)
{
 	UInt32 t;
	dbl dx,dz, r, idx,idz, spr, vpr, tx,tz;
    Int32 ks;
  
  	if (f->rnum<=0) {
       f->tx = ebasex; f->tz = ebasez;
       f->state=2; f->role=1;
       return;
    }
    if (fgt[f->tgn].state==0) {
        f->state=4;
        f->role=0;
        return;
    }

	//else look at plane
 	tx = fgt[f->tgn].ax; 	tz = fgt[f->tgn].az;
 
    dx = tx - f->ax;    dz = tz - f->az;
    idx = fint(dx); idz = fint(dz);
    r = isqrt( idx*idx + idz*idz); r=fdbl(r);
    dx = fdiv(dx, r); dz = fdiv(dz, r);
    
    spr = fmul(dx,f->vx) + fmul(dz,f->vz); //scalar product
    if (spr< 240) { //need to turn
    	vpr = fmul(dx, f->vz) - fmul(dz, f->vx); // vector product
     	if (vpr >0) {// turn rite ?
      		f->Kurs += fdbl(10);
        	f->Kren = fdbl(45);
        } else {
      		f->Kurs -= fdbl(10);
        	f->Kren = fdbl(-45);
        }
    } else {
        f->Kren = 0;
    }

   	ks = fint(f->Kurs)%360;
	if (ks<0) ks+=360;
   	f->vx = sina[ks];
   	f->vz = cosa[ks];
    if (fint(f->ay)/50 < f->H) f->vy = 50;
    if (fint(f->ay)/50 > f->H) f->vy = -50;
   	
 	if (Abs(f->ax - tx)<fdbl(2000) && Abs(f->az - tz)<fdbl(2000) && spr>=200) { //player in range of fire
  		RocketSend(f->tgn+10,-1, f->ax, f->ay - fdbl(5), f->az); // fire
    	f->rnum--;
    	t = TimGetTicks();
     	dx = bitrand(t*0xBE) % fdbl(3000); dz = bitrand(t*0xDEAD) % fdbl(3000);
      	f->tx = f->ax + dx; f->tz = f->az + dz; f->ty = fdbl(100);
       	f->role = 4; f->state = 2;						// and step on side
		return;      	
 	}
}

void FighterTroop(Fighter *f)
{
	UInt32 t = TimGetTicks();
 
 	if (f->ay<fdbl(400)) f->vy=50;
  	else f->vy=0;
 	if (t < f->timetogo) return;
  	if (f->rnum<=0) {
       f->state=2; f->role=1;
       f->tx = fdbl(3000); f->ty=0; f->tz = fdbl(21000);
    } else {
        troopsout=1;
        OutTrooper(f->ax, f->ay - fdbl(15), f->az);
        f->timetogo = t + 250; f->rnum--;
    }
}


void FighterThink(Fighter *f)
{
	switch(f->state) {
    case 1:
		if (f->ay>fdbl(200)) { f->state=2; f->vy=0; }
	    break;
    case 2:
 		FighterFlyTo(f);   	
	    break;
    case 3:
    	FighterPatrol(f);
	    break;
    case 4:
    	FighterAttackUser(f);	
	    break;
    case 5:
 		FighterAttackGround(f);   	
	    break;
    case 6:
    	FighterAttackPlane(f);	
	    break;
    case 7:
    	FighterTroop(f);
     	break;
    }
}
