//graphics functions for color 8bpp mode

UInt8 *pScr;

UInt32 hlinemask[2][4] = {
{0xFFFFFFFF, 0x00FFFFFF, 0x0000FFFF, 0x000000FF},
{0xFF000000, 0xFFFF0000, 0xFFFFFF00, 0xFFFFFFFF}
};

UInt32 hlinemask2[4][4] = {
{0xFF000000,0xFFFF0000,0xFFFFFF00,0xFFFFFFFF},
{0x00000000,0x00FF0000,0x00FFFF00,0x00FFFFFF},
{0x00000000,0x00000000,0x0000FF00,0x0000FFFF},
{0x00000000,0x00000000,0x00000000,0x000000FF},
};

#ifdef COLORED
#define DrawHline DrawHline8
#else
#define DrawHline(y,x1,x2,c) WinDrawLine(x1,y,x2,y)
#endif

#ifdef COLORED
void DrawHline8(Int32 y, Int32 x1, Int32 x2, UInt8 color) GFX;
void DrawHline8(Int32 y, Int32 x1, Int32 x2, UInt8 color) //x1 must be < x2
{
    UInt32 *p,*pe, c32,ms;
    Int32 i,s32,e32, start,end,s1,e1;

    if (y<0 || y>159) return;
    if (x1>x2) {
        Int32 t = x1;
        x1 = x2; x2 = t;
    }
    if (x2<0 || x1>159) return;
    if (x1<0) x1 = 0;
    if (x2>159) x2 = 159;

    i = y*160;
    start = i + x1;
    end = i + x2;
    s32 = start & 0xFFFFFFFC;
    e32 = end & 0xFFFFFFFC;
    s1 = start & 3;
    e1 = end & 3;

    c32 = color;
    c32 |= (c32<<16);
    c32 |= (c32<<8);

    if (s32!=e32) {
        if (s1) {
            ms = hlinemask[0][s1];
            p = (UInt32*)&pScr[s32];
            *p &= ~ms;
            *p |= ms & c32;
            s32 += 4;
        }
        if (e1<3) {
            ms = hlinemask[1][e1];
            p = (UInt32*)&pScr[e32];
            *p &= ~ms;
            *p |= ms & c32;
            e32 -= 4;
        }
        if (s32 <= e32) {
            p = (UInt32*)&pScr[s32];
            pe = (UInt32*)&pScr[e32];
            while(p<=pe)
                *p++ = c32;
        }
    } else {
        ms = hlinemask2[s1][e1];
        p = (UInt32*)&pScr[s32];
        *p &= ~ms;
        *p |= ms & c32;
    }
}
#endif



#ifdef COLORED
void DrawPolygon(Int32 *pts, UInt8 ptnum, UInt8 color) GFX;
void DrawPolygon(Int32 *pts, UInt8 ptnum, UInt8 color)
{
    Int32 i,imin,imax,ymin,ymax,y,  from,to,dx,dy,add,x,m;
    Int32 bresen_buffer[160][2];
    Int32 xmax,xmin;

    imin = imax = 0;
    ymin = ymax = pts[1];
    xmin = xmax = pts[0];
    for(i=1; i<ptnum; i++) {
        y = pts[i*2+1];
        if (y<ymin) {
            ymin = y;
            imin = i;
        }
        if (y>ymax) {
            ymax = y;
            imax = i;
        }
        x = pts[i*2];
        if (x>xmax) xmax = x;
        if (x<xmin) xmin = x;
    }

    to = imin;
    y = ymin;

    if (ymin==ymax) {
        DrawHline8(ymin,xmin,xmax,color);
        return;
    }

    if (ymin>159 || ymax<0 || xmax<0 || xmin>159) return;

    do {
        from = to;
        to = (to==0)?ptnum-1:to-1;
        dy = pts[to*2+1] - pts[from*2+1];
        if (!dy) {
            continue;
        }
        if(pts[to*2] > pts[from*2]) {
          add = 1;
          dx = pts[to*2] - pts[from*2];
        } else {
          add = -1;
          dx = pts[from*2] - pts[to*2];
        }

        m = dx/2;
        x = pts[from*2];

        while(y<pts[to*2+1]) {
          while(m>dy) { m-=dy; x+=add; }
          if(y<160 && y>-1)
    	    bresen_buffer[y++][0]=x;
          else
        	y++;
          m+=dx;
        }

    } while(to!=imax);

    to = imin;
    y = ymin;
    do {
        from = to;
        to = (to==ptnum-1)?0:to+1;
        dy = pts[to*2+1] - pts[from*2+1];
        if (!dy) {
            continue;
        }
        if(pts[to*2] > pts[from*2]) {
          add = 1;
          dx = pts[to*2] - pts[from*2];
        } else {
          add = -1;
          dx = pts[from*2] - pts[to*2];
        }

        m = dx/2;

        x = pts[from*2];

        while(y<pts[to*2+1]) {
          while(m>dy) { m-=dy; x+=add; }
          if(y < 160 && y>-1)
    	    bresen_buffer[y++][1]=x;
          else
    	    y++;
          m+=dx;
        }
    } while(to!=imax);
/*    y = pts[imax*2+1];     //lowest point
    if (y>=0 && y<160)
    	bresen_buffer[y][0] = bresen_buffer[y][1] = pts[imax*2];
  */
    if (ymin<0) ymin=0;
    if (ymax>159) ymax=159;
    for(y=ymin;y<ymax;y++)
    DrawHline8(y, bresen_buffer[y][0], bresen_buffer[y][1], color);
}
#endif



#ifdef COLORED
void DrawLandnSky(Int32 x1, Int32 y1, Int32 x2, Int32 y2, Int16 skyfirst, Int16 sy) GFX;
void DrawLandnSky(Int32 x1, Int32 y1, Int32 x2, Int32 y2, Int16 skyfirst, Int16 sy) //skyfirst:0 or 1
{
    Int32 bresen_buffer[160];
    Int32 x,y,m,dx,dy,add,c1,c2,t,s1=clrSky,s2=clrGround;
    UInt32 *p, c32,*pe;

    if (y1>y2) {
        dx = x1; dy = y1;
        x1 = x2; y1 = y2;
        x2 = dx; y2 = dy;
    }

    if (x2 <= x1) {
        c1 = clrSky; c2 = clrGround;
    } else {
        c2 = clrSky; c1 = clrGround;
    }
    if (!skyfirst) {
        t = c1; c1 = c2; c2 = t;
        t = s1; s1 = s2; s2 = t;
    }
    if (y1>0) {
        c32 = s1;
        c32 |= c32<<16;
        c32 |= c32<<8;
        p = (UInt32*) pScr;
        if (y1<sy)
            pe = (UInt32*) &pScr[y1*160];
        else
            pe = (UInt32*) &pScr[sy*160];
        while(p<pe)
            *p++ = c32;
    }
    if (y2<sy) {
        c32 = s2;
        c32 |= c32<<16;
        c32 |= c32<<8;
        if (y2>=0)
            p = (UInt32*) &pScr[y2*160];
        else
            p = (UInt32*) pScr;
        pe = (UInt32*) &pScr[sy*160];
        while(p<pe)
            *p++ = c32;
    }
    if (y2<0 || y1>=sy) return;

    if (x2>x1) {
        add = 1;
        dx = x2 - x1;
    } else {
        add = -1;
        dx = x1 - x2;
    }
    m = dx/2; dy = y2 - y1;
    x = x1; y = y1;
    if (!dy) return;
    while(y<=y2) {
        while(m>dy) { m-=dy; x+=add; }
        if (y>=0 && y<sy)
            bresen_buffer[y++] = x;
        else
            y++;
        m+=dx;
    }

    if (y1<0) y1 = 0;
    if (y2>sy-1) y2 = sy-1;
    for(y=y1;y<=y2;y++) {
        x = bresen_buffer[y];
        DrawHline8(y, 0, x-1, c1);
        DrawHline8(y, x, 160, c2);
    }
}
#endif



Int32 old_width, old_depth, old_height;
Boolean old_enabcol;


Int32 GraphicsMode() GFX;
Int32 GraphicsMode() //switch to required graph mode, 0-ok, else-error
{
    Int32 width, depth, height;
    Boolean enabcol;
    Err err;

    WinScreenMode(winScreenModeGet, &old_width, &old_height, &old_depth, &old_enabcol);
	#ifdef COLORED
    depth = 8; enabcol = 1; width = height = 160;
    #else
    depth = 1; enabcol = 0; width = height = 160;
    #endif
 	err = WinScreenMode(winScreenModeSet, &width, &height, &depth, &enabcol);
    return err;
}

void RestoreMode() GFX;
void RestoreMode() //switch to previous graph mode
{
    WinScreenMode(winScreenModeSet, &old_width, &old_height, &old_depth, &old_enabcol);
}


UInt8 *pScreenBits, *pBufferBits;
WinHandle hwndScreen, hwndBuffer;
UInt32 old_LSSA;
BitmapType* pBmpBuffer;

Int32 InitScreens() GFX;
Int32 InitScreens()
{
    UInt16 err;
    BitmapType *pBmp;

    hwndScreen = WinGetDisplayWindow();
    hwndBuffer = WinCreateOffscreenWindow (160, 160, screenFormat, &err);
    if (err != errNone) return err;

    pBmp = WinGetBitmap(hwndScreen);
    pScreenBits = (UInt8*) BmpGetBits (pBmp);

    pBmpBuffer = WinGetBitmap(hwndBuffer);
    pBufferBits = (UInt8*) BmpGetBits (pBmpBuffer);

    pScr = pScreenBits;
    return 0;
}

void EndScreens() GFX;
void EndScreens()
{
    WinDeleteWindow(hwndBuffer, false);
}

Int32 DrawOffscreen() GFX;
Int32 DrawOffscreen() // 0-ok
{
    WinSetDrawWindow(hwndBuffer);
    pScr = pBufferBits;
    return 0;
}

Int32 DrawOnscreen() GFX;
Int32 DrawOnscreen() // 0-ok
{
    WinSetDrawWindow(hwndScreen);
    pScr = pScreenBits;
    return 0;
}

void ShowDrawn() GFX;
void ShowDrawn() // copies buffer to screen using rcview
{
#ifdef HIDENSITY
	WinCopyRectangle(hwndBuffer, hwndScreen, &rcview, 0,0, winPaint);
#else
    UInt32 *pb =(UInt32*)pBufferBits, *pe = (UInt32*)&pBufferBits[rcview.extent.y*160], *ps = (UInt32*)pScreenBits;
    while(pb<pe)
        *ps++ = *pb++;
#endif
}

#ifdef HIDENSITY
#define WDrawPixel WinDrawPixel
#else
void WDrawPixel(Coord x, Coord y) GFX;
void WDrawPixel(Coord x, Coord y)
{
    if (y<0 || y>159 || x>159 || x<0) return;
    pScr[y*160 + x] = clrCurrent;
}
#endif


UInt8 WSetForeColor(UInt8 color) GFX;
UInt8 WSetForeColor(UInt8 color)
{
    clrCurrent = color;
    #ifdef COLORED
    return WinSetForeColor(color);
    #else
    return 1;
    #endif
}