void LauncherInit(Launcher *l)
{
	l->timeout=0; l->alive=0;
 	ObjectCreate(&(l->obj),14,7,0);
 	ObjectCopy(&(l->obj), &man);
}

void LauncherSet(Launcher *l, dbl X, dbl Z)
{
	Int16 x;
 	l->ax = X; l->az = Z; l->ay = 0; l->alive=1;
	for(x=0;x<man.ndots;x++) {
     	l->obj.dots[x].ax = man.dots[x].ax + X;
     	l->obj.dots[x].az = man.dots[x].az + Z;
     	l->obj.dots[x].ay = man.dots[x].ay;
    }
}

void LauncherFree(Launcher *l)
{
	ObjectFree(&(l->obj));
}

void LauncherFire(Launcher *l)
{
 	Int32 x, dx,dy,dz,r, dmin=10000, d;
  	dbl px,py,pz, bx,by,bz;
  	dbl v0[3] = {0, 0, 0}, v[3];
   
   	v0[2] = maSpeed/2;
   	MatrVect(R1, v0, v);
    
   	bx = px = mx; by = py = my; bz = pz = mz;
    for(x=0;x<12;x++) {
        dx = fint(l->ax - px); dy = fint(l->ay - py); dz = fint(l->az - pz);
        r = isqrt(dx*dx + dy*dy + dz*dz);
        d = Abs(r - 250*x);
        if (d<dmin) {
            bx = px; by = py; bz = pz; dmin = d;
        }
        px += v[0]; py += v[1]; pz += v[2];
    }
    //make error
    bx += v[0]*2; by += v[1]*2; bz += v[2]*2;
    bx += fdbl(bitrand(bx)%70); by += fdbl(bitrand(by)%70); bz += fdbl(bitrand(bz)%70);
    
	x=RocketSend(1, -1, l->ax, l->ay + fdbl(1), l->az);
 	if (x>=0) {
	 	rkt[x].tx = bx; rkt[x].ty = by; rkt[x].tz = bz;
    }
    l->timeout = 3000;
}


void BombInit(Bomb *b)
{
	ObjectCreate(&(b->obj), 2,1,0);
 	b->obj.lines[0].n1 = 0; 	b->obj.lines[0].n2 = 1; b->state=0;
}

void BombFree(Bomb *b)
{
	ObjectFree(&(b->obj));
}

void BombLaunch(Bomb *b, dbl x, dbl y, dbl z, dbl *mv)
{
 	b->ax = x; b->ay = y; b->az = z; b->state = 1;
	b->vx = mv[0]; b->vy = mv[1]; b->vz = mv[2]; 
}

void BombFall(Bomb *b, Int32 dt)
{
	b->vy -= fdbl(dt)*dt/1000;
  	b->ax += b->vx;  	b->ay += b->vy;  	b->az += b->vz;
   	if (b->ay<=0) {
        Bang(b->ax, 0, b->az);
        b->state=0;
    }
}

void DrawBombs()
{
	Int16 x;
 	dbl dx,dy,dz,l;
 	for(x=0;x<16;x++)
  		if (bmb[x].state && Abs(bmb[x].ax-mx)<fdbl(1000) && Abs(bmb[x].ay-my)<fdbl(1000)) {
        	dx = bmb[x].vx; dy = bmb[x].vy; dz = bmb[x].vz;
         	l = isqrt(dx*dx+dy*dy+dz*dz); l/=2; if (l==0) l=1;
          	dx = fdiv(dx,l); dy = fdiv(dy,l); dz = fdiv(dz,l);
        	bmb[x].obj.dots[0].ax = bmb[x].ax;
        	bmb[x].obj.dots[0].ay = bmb[x].ay;
        	bmb[x].obj.dots[0].az = bmb[x].az;
        	bmb[x].obj.dots[1].ax = bmb[x].ax-dx;
        	bmb[x].obj.dots[1].ay = bmb[x].ay-dy;
        	bmb[x].obj.dots[1].az = bmb[x].az-dz;
         	ObjectDraw(&(bmb[x].obj));
        }
}


void TrooperInit(Trooper *t)
{
	ObjectCreate(&(t->obj),15,20,10);
 	ObjectCopy(&(t->obj), &trooper);
  	t->state=0;
}

void TrooperSet(Trooper *t, dbl x, dbl y, dbl z)
{
	Int16 i;
 	
 	t->ax = x; t->ay = y; t->az = z; t->state=1;
  	for(i=0;i<t->obj.ndots;i++) {
       t->obj.dots[i].ax = trooper.dots[i].ax + x;
       t->obj.dots[i].ay = trooper.dots[i].ay + y;
       t->obj.dots[i].az = trooper.dots[i].az + z;
    }
}

void TrooperFall(Trooper *t, Int32 dt)
{
	Int16 i;
	
 	t->ay -= fdbl(dt)/20;
  	if (t->ay<=0) t->state=0;
  	for(i=0;i<t->obj.ndots;i++) 
       t->obj.dots[i].ay = trooper.dots[i].ay + t->ay;
}

void TrooperFree(Trooper *t)
{
	ObjectFree(&(t->obj));
}

void OutTrooper(dbl x,dbl y, dbl z)
{
	Int16 i;
 	for(i=0;i<16;i++) 
      	if (trp[i].state==0) {
           TrooperSet(&(trp[i]),x,y,z);
           break;
    	}
}

