void BoomInit(Boom *b)
{
	Int16 i;
   
 	ObjectCreate(&(b->obj), 32,16,0);
  	for(i=0;i<16;i++) {
        b->obj.lines[i].n1 = i; b->obj.lines[i].n2 = i+16; 
    }
    b->t0=0;
}

void BoomFree(Boom *b)
{
 	ObjectFree(&(b->obj));
}

void BoomBang(Boom *b, dbl x0, dbl y0, dbl z0)
{
	Int16 i;
 	dbl x,y,z,r,k;
 	Int32 ix,iy,iz;
  
  	b->t0=TimGetTicks();
  	for(i=0;i<16;i++) {
       	x = bitrand((Int32)(i+1+b->t0)*0xDEAD +(Int32)b);
       	y = bitrand((Int32)(i+100+b->t0)*0xBED +(Int32)b);
       	z = bitrand((Int32)(i+1000+b->t0)*0xBABE +(Int32)b);
        x = x % fdbl(10); y = y % fdbl(10); z = z % fdbl(10);
        if (y0<fdbl(20)) y = Abs(y); //near ground explosion
        ix = fint(x); iy = fint(y); iz = fint(z);
        r = isqrt(ix*ix + iy*iy + iz*iz); r = fdbl(r);
        if (r>fdbl(10)) {
            k=fdiv(fdbl(10),r);
            x = fmul(x,k); y = fmul(y,k); z = fmul(z,k);
        }
        b->obj.dots[i].ax = x +x0; b->obj.dots[i].ay = y+y0; b->obj.dots[i].az = z +z0;
        b->obj.dots[i+16].ax = x/2 +x0; b->obj.dots[i+16].ay = y/2 +y0; b->obj.dots[i+16].az = z/2 +z0;
    }                      
}

void BoomGo(Boom *b, UInt32 tk)
{
	Int16 i;
 	dbl d;
  
  	b->visible=0;
 	if (tk - b->t0 > 500 && tk-b->t0 < 10000) {
      b->t0=0;
      return;
    }
    for(i=0;i<16;i++) {
        d = b->obj.dots[i].ax - b->obj.dots[i+16].ax; d/=2;
        b->obj.dots[i].ax += d; b->obj.dots[i+16].ax += d;
        d = b->obj.dots[i].ay - b->obj.dots[i+16].ay; d/=2;
        b->obj.dots[i].ay += d; b->obj.dots[i+16].ay += d;
        d = b->obj.dots[i].az - b->obj.dots[i+16].az; d/=2;
        b->obj.dots[i].az += d; b->obj.dots[i+16].az += d;
    }
    if (Abs(b->obj.dots[0].ax - MX) < fdbl(2000) && Abs(b->obj.dots[0].az - MZ) < fdbl(2000)) b->visible=1;
}

void Destroy(Int16 tgn)
{
	Int32 x;
 	GroupFree(&(W.grp[tgn]));
 	GroupCreate(&(W.grp[tgn]), 1);
  	ObjectCreate(&(W.grp[tgn].obj[0]),32,16,0);
   	for(x=0;x<32;x++) {
        W.grp[tgn].obj[0].dots[x].ax = bitrand((x+1)*0xBADBAD) % W.grp[tgn].R + W.grp[tgn].cx;
        W.grp[tgn].obj[0].dots[x].ay = 0;
        W.grp[tgn].obj[0].dots[x].az = bitrand((x+100)*0xBADBAD) % W.grp[tgn].R + W.grp[tgn].cz;
    }
    for(x=0;x<16;x++) {
        W.grp[tgn].obj[0].lines[x].n1 = x;        W.grp[tgn].obj[0].lines[x].n2 = x+16;
    }
    MissionDestroy(tgn);
}
            

void RocketInit(Rocket *r)
{
	r->state=0; r->tgn=-1;
 	ObjectCreate(&(r->obj),8,6,0);
  	r->obj.lines[0].n1 = 0; r->obj.lines[0].n2 = 1;
  	r->obj.lines[1].n1 = 0; r->obj.lines[1].n2 = 2;
  	r->obj.lines[2].n1 = 0; r->obj.lines[2].n2 = 3;
  	r->obj.lines[3].n1 = 4; r->obj.lines[3].n2 = 5; //tail
  	r->obj.lines[4].n1 = 5; r->obj.lines[4].n2 = 6;
  	r->obj.lines[5].n1 = 6; r->obj.lines[5].n2 = 7;
}

void RocketFree(Rocket *r)
{
	ObjectFree(&(r->obj));
}

void RocketDraw(Rocket *r)
{
	UInt8 col;
 	col = WSetForeColor(clrSmoke);
	ObjectDraw(&(r->obj));
 	WSetForeColor(col);
}
 
Int16 RocketFly(Rocket *r, Int32 dt) // 1 if time to bang, else 0
{
	dbl dx,dy,dz, rr, spd,spd0;
 	Int32 idx,idy,idz,x;
  
  	r->visible=0;
 	if (r->state==3 || r->state==7) {
      	r->tx = mx;
       	r->ty = my;
        r->tz = mz;
        danger=1;
    }
    if (r->state==1 && r->tgn>-1) {
      	r->tx = W.grp[r->tgn].tx;
       	r->ty = W.grp[r->tgn].ty;
        r->tz = W.grp[r->tgn].tz;
    }
    if (r->state>9) {
        r->tx = fgt[r->state-10].ax;
        r->ty = fgt[r->state-10].ay;
        r->tz = fgt[r->state-10].az;
    }

    dx = r->tx - r->ax;    dy = r->ty - r->ay;    dz = r->tz - r->az;
    idx = fint(dx);    idy = fint(dy);    idz = fint(dz);
    rr = isqrt(idx*idx + idy*idy + idz*idz); 
    if (rr<1) rr=1; rr=fdbl(rr);
    spd0 = fdbl(5);  
    spd =  fmul(spd0, fdbl(dt));//500*dt/100
    
    if (r->bad && (rr - spd*3 <0)) r->state=1;
    if (rr==0 || (rr - spd <0)) { //bang
       	if (r->state>9) {
        	fgt[r->state-10].state=0;
         	ltn=-1;
         }
        if (r->state==3 && viewstate<90) {
            SetText("Killed by an enemy fighter!");    killed=1;
        	Die();
        } else
        if (r->state==7 && viewstate<90) { 
            SetText("Killed by ZRK!"); killed=1;
        	Die();
        }
        else Bang(r->ax, r->ay, r->az);
    	r->state=0;
//      	if (r->tgn>-1 && W.grp[r->tgn].nobj>1)  //ground object destroyed
//       		Destroy(r->tgn);
    	return 1; 
    }
    r->vx = fdiv(dx, rr); r->vy = fdiv(dy, rr); r->vz = fdiv(dz, rr);
    
    r->ax += fmul(r->vx, spd);    r->ay += fmul(r->vy, spd);    r->az += fmul(r->vz, spd);
    
    for(x=7;x>3;x--) { //make tail
    	r->obj.dots[x].ax = r->obj.dots[x-1].ax;
    	r->obj.dots[x].ay = r->obj.dots[x-1].ay;
    	r->obj.dots[x].az = r->obj.dots[x-1].az;
    }
    r->obj.dots[3].ax = r->ax;    r->obj.dots[3].ay = r->ay;    r->obj.dots[3].az = r->az;
    r->obj.dots[0].ax = r->ax + r->vx*3;    r->obj.dots[0].ay = r->ay + r->vy*3;    r->obj.dots[0].az = r->az + r->vz*3;
    r->obj.dots[1].ax = r->ax;    
    r->obj.dots[1].ay = r->ay + 128;    
    r->obj.dots[1].az = r->az;
    r->obj.dots[2].ax = r->ax - fdiv(r->vz,fdbl(4));    
    r->obj.dots[2].ay = r->ay;    
    r->obj.dots[2].az = r->az + fdiv(r->vx,fdbl(4));
    
    if (Abs(r->ax - MX) < fdbl(2000) && Abs(r->az - MZ) < fdbl(2000)) r->visible=1;
    return 0;
}



