#include <PalmOS.h>
#include <DLServer.h>
#include <stdio.h>

//#define EMULATING
#define HIDENSITY //always on(?)
//#define COLORED

//#define PEACE
//#define FPS

#define WSEC  __attribute__ ((section ("world")))
#define WSEC2  __attribute__ ((section ("world2")))
#define GFX  __attribute__ ((section ("gfx")))

typedef Int32 	dbl;	// fixed point - 24.8  

#define fmul(a,b)	((a)*(b) /(Int32)256)
#define fdiv(a,b)	((a)*(Int32)256/(b))
#define fdbl(a)		((Int32)(a)*(Int32)256)		// int to dbl
#define fint(a)		((Int32)(a)/(Int32)256)		// dbt to int

typedef dbl*	matr;

#define clrSand 0x79
#define clrGrass 0xC2

UInt8 clrFighter=0xDC, clrGround=clrSand, clrSky=0x5A, clrCurrent=0xFF, clrFarm=0x99,
 clrConcrete0=0xDC, clrConcrete =0xDE, // Concrete = Concrete1
 clrMilitary0=0xC4, clrMilitary1=0xC3, clrCube0, clrCube1, clrCube2=0xDF,
 clrSmoke=0xD9, clrFire=/*0x7D*/0xD8, clrBlack=0xD9,
 clrOcto0=0xA0, clrOcto1=0x9F;

RectangleType rcview;

UInt16 keyUp=vchrPageUp, keyDown=vchrPageDown, keyA=vchrHard1, keyB=vchrHard2, keyC=vchrHard3, keyD=vchrHard4;

Int32 inline bitrand(Int32 x)
{
    register Int32 y;
    y=x ^ (x<<8) ^ (x>>8);
    y=y ^ (y>>4) ^ (y<<4);
    return y;
}

#include "graphics.c"

void outdblg(dbl x, Coord sx, Coord sy)
{
    Int32 l;
    Char buf[64];

    buf[0]=0;
    if (x<0 && x>-256) sprintf(buf,"-");
    sprintf(&(buf[StrLen(buf)]),"%ld.", x/256);
    l = (x&255);
    if (x<0 && l) l=256-l;
    l = l*100/256;
    if (l<10) sprintf(&(buf[StrLen(buf)]),"0");
    sprintf(&(buf[StrLen(buf)]),"%ld ", l );
    WinPaintChars(buf, StrLen(buf), sx,sy);
}

void outintg(Int32 x, Coord sx, Coord sy)
{
    Char buf[64];
    sprintf(buf,"%ld", x);
    WinPaintChars(buf, StrLen(buf), sx,sy);
}



void SaveData_far(Int32 code) WSEC;
void SaveData_far(Int32 code)
{

	Char cr[] = "PFgt",
	tp[] = "fd11";
 	UInt32 *c = (UInt32*)&cr, *t = (UInt32*)&tp;
  	Int32 d=code, creating=0;
  	Err er;
   	DmOpenRef dbP;
  	void *data;
   	UInt16 ix=0;//dmMaxRecordIndex;
    MemPtr p;
    LocalID lid;
    UInt16 cardNo,attr;

	er=DmCreateDatabase(0, "PalmFighterFD11", *c, *t, false);
 	if (er==errNone)
  		creating = 1;
  	else
    if (er!=dmErrAlreadyExists) {
    	printf("DmCreate %d\n",er);
     	return;
    }
    dbP = DmOpenDatabaseByTypeCreator(*t, *c, dmModeReadWrite);
    if (dbP==0){
    	printf("DmOpen err\n");
     	return;
    }
    if (creating)
	    data = DmNewRecord(dbP, &ix, 4+6*2);
    else
    	data = DmGetRecord(dbP,0);
    if (!data) {
    	printf("DmNewRec err\n");
     	return;
    }
    p = MemHandleLock(data);
	er = DmWrite(p, 0, &d, 4);
	er = DmWrite(p, 4, &keyUp, 2);
	er = DmWrite(p, 6, &keyDown, 2);
	er = DmWrite(p, 8, &keyA, 2);
	er = DmWrite(p, 10, &keyB, 2);
	er = DmWrite(p, 12, &keyC, 2);
	er = DmWrite(p, 14, &keyD, 2);
 	MemPtrUnlock(p);
    if (er!=errNone) {
    	printf("DmWrite %d\n",er);
     	return;
    }
    DmReleaseRecord (dbP, ix, false);
    DmOpenDatabaseInfo(dbP, &lid, NULL, NULL, &cardNo, NULL);
    DmCloseDatabase(dbP);
	DmDatabaseInfo(cardNo, lid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	attr |= dmHdrAttrBackup;
 	DmSetDatabaseInfo(cardNo, lid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL,NULL, NULL, NULL);
}


//void SaveData(Int32 code) WSEC;
void SaveData(Int32 code)
{
	SaveData_far(code);
}

Int32 LoadData_far(Int16 loadkeys) WSEC;
Int32 LoadData_far(Int16 loadkeys)
{
	Char cr[] = "PFgt",
	tp[] = "fd11";
 	UInt32 *c = (UInt32*)&cr, *t = (UInt32*)&tp;
  	Int32 d, *cd;
   	DmOpenRef dbP;
  	void *data;
    MemPtr p;
    UInt16 *p16;
    LocalID lid;
    UInt16 cardNo,attr;

    dbP = DmOpenDatabaseByTypeCreator (*t, *c, dmModeReadWrite);
    if (dbP==0){
     	return 0;
    }
    data = DmGetRecord (dbP, 0);
    if (!data) {
    	printf("DmGetRec err\n");
     	return 0;
    }
    p = MemHandleLock(data);
	cd = (Int32*)p;
 	d = *cd;
  	if (loadkeys) {
	  	p16 = (UInt16*)p;
	    keyUp = p16[2];
	    keyDown = p16[3];
	    keyA = p16[4];
	    keyB = p16[5];
	    keyC = p16[6];
	    keyD = p16[7];
    }
 	MemPtrUnlock(p);
    DmReleaseRecord (dbP, 0, false);
    DmOpenDatabaseInfo(dbP, &lid, NULL, NULL, &cardNo, NULL);
    DmCloseDatabase(dbP);
	DmDatabaseInfo(cardNo, lid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	attr |= dmHdrAttrBackup;
 	DmSetDatabaseInfo(cardNo, lid, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL,NULL, NULL, NULL);
    return d;
}

//Int32 LoadData(Int16 loadkeys) WSEC;
Int32 LoadData(Int16 loadkeys)
{
	return LoadData_far(loadkeys);
}

void MatrNew(matr *a)
{
    Int16 x;
    *a = (matr)MemPtrNew(9*sizeof(dbl));
    for(x=0;x<9;x++) (*a)[x]=0;
}

void MatrNewE(matr *a)
{
    Int16 x,y;
    *a = (matr)MemPtrNew(9*sizeof(dbl));
    for(x=0;x<3;x++)
	for(y=0;y<3;y++) (*a)[y*3+x]=fdbl((x==y));
}

void MatrFree(matr a)
{
    MemPtrFree(a);
}

void MatrCopy(matr from, matr to)
{
    Int16 x;
    for(x=0;x<9;x++)
		to[x]=from[x];
}

void MatrMul(matr a, matr b) // B = AB
{
    dbl c[3][3], s;
    Int16 x,y,i;
    
    for(y=0;y<3;y++)
	for(x=0;x<3;x++) {
	    s = 0; i = y*3;
	    //for(k=0;k<3;k++) //loop open
		s += fmul( a[i++], b[0*3+x] );
		s += fmul( a[i++], b[1*3+x] );
		s += fmul( a[i++], b[2*3+x] );
	    c[y][x] = s;
	}
	i=0;
    for(y=0;y<3;y++) {
		//for(x=0;x<3;x++) //loop open
	    b[i++]=c[y][0];
	    b[i++]=c[y][1];

	    b[i++]=c[y][2];
    }
}

void MatrVect(matr a, dbl *v, dbl *r) // r = Av
{
    Int16 i;
    dbl s;
    i = 0;
		s = 0;
	    s += fmul(a[i++], v[0]);
	    s += fmul(a[i++], v[1]);
	    s += fmul(a[i++], v[2]);
		r[0] = s;
		s = 0;
	    s += fmul(a[i++], v[0]);
	    s += fmul(a[i++], v[1]);
	    s += fmul(a[i++], v[2]);
		r[1] = s;
		s = 0;
	    s += fmul(a[i++], v[0]);
	    s += fmul(a[i++], v[1]);
	    s += fmul(a[i++], v[2]);
		r[2] = s;
}


dbl Sin(dbl x)
{
    dbl s, a, x2, dlt;
    Int32 b,k, k2;
    
    s=0; a=x; b=1; x2=fmul(x,x);
    s = a;
    for(k=1;k<10;k++) {
		a = fmul(a,x2);
		k2=k*2;
		b = b*k2*(k2+1)*(-1);
		dlt = a/b;
		s += dlt;
		if (dlt==0) break;
    }
    return s;
}

dbl sina[360], cosa[360];
dbl ScrZ = fdbl(113); // in points
dbl mx,my,mz, mSpeed, maSpeed, wmaSpeed, Fuel;

dbl mKurs, mKren, mTang, RotSpeedy; //in degrees
matr R, R1, Rt, Rcrm,Msb, cR1;

dbl MX,MY,MZ, cKurs,cKren,cTang;
Int16 viewstate, weapon, rocketsleft, ltn, traps, danger; //ltn - locked target number
Int32 ltx, lty, ltd, showR, showT, showTh, gltn; //gltn - ground locked target number
Int16 falling, mission, bombsleft, Shift, troopsout, inair, mcomplete, ejected, killed, failed;
dbl basex1,basex2,basez1,basez2;
dbl ebasex, ebasez;

UInt16 TPS; //ticks per second

typedef struct {
    dbl ax,ay,az, rx,ry,rz;
    Int32 df, cx,cy;
} Dot;

void DotCalc(Dot* dots, Int16 nd)
{
    Int16 i;
    dbl sx,sy, x,y,z, v[3], v1[3];
    
    for(i=0;i<nd;i++)
	    if (dots[i].df) {
    	    v[0] = dots[i].ax -MX;
    	    v[1] = dots[i].ay -MY;
    	    v[2] = dots[i].az -MZ;
    	    MatrVect(R, v, v1);
    	    x = dots[i].rx = v1[0];

    	    y = dots[i].ry = v1[1];
    	    z = dots[i].rz = v1[2];
    	    if (z>0) {	
    		    sx = fdiv(x, z);
        	    sx = fmul(ScrZ, sx);
        		dots[i].cx = fint(sx) + 80;
        	    sy = fdiv(-y, z);
        		sy = fmul(ScrZ, sy);
        		dots[i].cy = fint(sy) + 65;
    	 	} else {
        		dots[i].cx=-1; dots[i].df=2; // invisible
    	    }
	    }

}

void WDrawLine(Int32 x1, Int32 y1, Int32 x2, Int32 y2)
{
 	dbl k,b;
    Int32 sx1,sy1,sx2,sy2, ymin, ymax, tx,ty;
  	
    if (x1==x2) {
        if (x1<0 || x1>159) return;
        if (y1<y2) {
            sy1=y1; sy2=y2;
        } else {
            sy1=y2; sy2=y1;
        }
        if (sy2<0 || sy1>159) return;
        if (sy1<0) sy1=0;
        if (sy2>159) sy2=159;
        WinDrawLine((Coord)x1,(Coord)sy1,(Coord)x2,(Coord)sy2);
    } else {
        if (x1<x2) {
             sx1=x1; sy1=y1; sx2=x2; sy2=y2;
        } else {
             sx1=x2; sy1=y2; sx2=x1; sy2=y1;
        }
        if (sx2<0 || sx1>159) return;
        if (y1<y2) {
            ymin=y1; ymax=y2;
        } else {
            ymin=y2; ymax=y1;
        }
        if (ymax<0 || ymin>159) return;

        k = fdiv( fdbl(y2-y1), fdbl(x2-x1) );
        if (abs(x1) < abs(x2))
	        b = fdbl(y1) - fmul(k, fdbl(x1));    
        else
	        b = fdbl(y2) - fmul(k, fdbl(x2));    
          
        if (sx1<0) {
            sx1 = 0;  sy1 = fint( b );
        }
        if (sx2>159) {
            sx2 = 159;  sy2 = fint( fmul(k, fdbl(159)) + b);
        }
        if (k==0) {
            DrawHline(sy1, sx1, sx2, clrCurrent);
            return;
        }
        if (sy2<sy1) {
            tx=sx1; ty=sy1; sx1=sx2; sy1=sy2; sx2=tx; sy2=ty;

		}
        if (sy1<0) {
            sy1=0; sx1 = fint( fdiv(-b, k) );
        }
        if (sy2>159) {
            sy2=159; sx2 = fint( fdiv(fdbl(159) - b, k) );
        }
        WinDrawLine((Coord)sx1,(Coord)sy1,(Coord)sx2,(Coord)sy2);                
    }
}





typedef struct {
    Int8 n1, n2, df;
} Line;

typedef struct {
    UInt8 li[4], nli, color, draw;
    dbl nx,ny,nz;
    UInt8 *di; // dots indexes
} Plane;

typedef struct {
    Dot* dots;
    Line* lines;
    Plane* planes;
    Int8 ndots, nlines, nplanes;

    Int8 polygonal, always;
} Object;


void ObjectCreate(Object* obj, Int8 nd, Int8 nl, Int8 np)
{
    Int16 i;

    obj->dots = (Dot*) MemPtrNew( nd*sizeof(Dot) );
    obj->ndots = nd;
    obj->lines = (Line*) MemPtrNew( nl*sizeof(Line) );

    obj->nlines = nl;
    if (np>0) {
		obj->planes = (Plane*) MemPtrNew( np*sizeof(Plane) );
        for(i=0;i<np;i++) {
            obj->planes[i].color = 0;
            obj->planes[i].di = NULL;
        }
    }

	obj->nplanes = np;
 	obj->polygonal = 0;
  	obj->always = 0;
}

void ObjectCopy(Object *dst, Object *src) // copy dots and lines. dst must be created
{
	Int16 x;
 	dst->polygonal = src->polygonal;
    dst->always = src->always;
 	for(x=0;x<src->ndots;x++) {
    	dst->dots[x].ax = src->dots[x].ax;
    	dst->dots[x].ay = src->dots[x].ay;
    	dst->dots[x].az = src->dots[x].az;
    }
    for(x=0;x<src->nlines;x++) {
        dst->lines[x].n1 = src->lines[x].n1;
        dst->lines[x].n2 = src->lines[x].n2;
    }

    if (src->nplanes)
	    MemMove(dst->planes, src->planes, src->nplanes * sizeof(Plane));
}

void ObjectFree(Object *obj)
{
    MemPtrFree(obj->dots);
    MemPtrFree(obj->lines);
    if (obj->nplanes>0) 
		MemPtrFree(obj->planes);
}


void Intersect(Dot *dotgood, Dot *dotbad, Int32 *isx, Int32 *isy)
{
    dbl alpha, badz, rz, ry, rx;
    Int32 sx,sy;

	badz = dotbad->rz;
    alpha = fdiv( fdbl(1) - badz,  dotgood->rz - badz );
    rz = fdbl(1);
    badz = dotbad->rx;
    rx = badz + fmul( alpha, dotgood->rx - badz );
    badz = dotbad->ry;
    ry = badz + fmul( alpha, dotgood->ry - badz );
    rx = fdiv(rx, rz);
	rx = fmul(ScrZ, rx);
	sx = fint(rx);
	ry = fdiv(-ry, rz);
	ry = fmul(ScrZ, ry);
	sy = fint(ry);

 	*isx = sx + 80; *isy = sy + 65;
}

void ObjectDraw(Object *obj) GFX;
void ObjectDraw(Object *obj)
{
    UInt8 l,p, n1,n2,t,dtp, good, bad,pi,nd, drawn=0;
    dbl vx,vy,vz, pr;
    Int32 sx,sy,i,j;
    Int32 pts[12]; // screen points of polygon
    UInt8 *di;
    Dot *cdot;

  #ifdef COLORED
    if (obj->polygonal) {
    	if (obj->always) {
	        for(i=0;i<obj->ndots;i++)
    	    	obj->dots[i].df=1;
		    for(p=0;p<obj->nplanes;p++)
      			obj->planes[p].draw = 1;


        } else { //not always
	        for(i=0;i<obj->ndots;i++)
    	    	obj->dots[i].df=0;
			for(p=0;p<obj->nplanes;p++) {
      		    t = obj->planes[p].li[0];
      	    	t = obj->lines[t].n1;
      		    vx = obj->dots[t].ax - MX;
      		    vy = obj->dots[t].ay - MY;
      		    vz = obj->dots[t].az - MZ;
      		    pr = vx * obj->planes[p].nx +
      			     vy * obj->planes[p].ny +	
      			     vz * obj->planes[p].nz;
      		    if (pr<0) {
      				//for(l=0; l<obj->planes[p].nli; l++)
      				//    obj->lines[ obj->planes[p].li[l] ].df=1;
                    obj->planes[p].draw = 1;
                    for(i=0;i<obj->planes[p].nli;i++)
                    	obj->dots[ obj->planes[p].di[i] ].df = 1;
                } else
                	obj->planes[p].draw = 0;
  	    	}
        }//if always
       	DotCalc(obj->dots, obj->ndots);

	    for(p=0;p<obj->nplanes;p++)
    	    if (obj->planes[p].di && obj->planes[p].draw) {
        	    pi = 0; di = obj->planes[p].di;
            	nd = obj->planes[p].nli;
	    		for(i=0;i<nd;i++) {
	          		cdot = &obj->dots[di[i]];
	            	if (cdot->df==1) { //good dot
						pts[pi++] = cdot->cx;
						pts[pi++] = cdot->cy;
	     			} else { //df==2 bad dot
	        			j = i-1;
	           			if (j<0) j += nd;
	              		j = di[j];
	        			if (obj->dots[j].df==1) { //previous is good
	               			Intersect(&obj->dots[j], cdot, &sx, &sy);
							pts[pi++] = sx;
							pts[pi++] = sy;
	               		}
		        		j = (i+1)%nd;
	        	      	j = di[j];
	                    if (obj->dots[j].df==1) { // next is good
	    	           		Intersect(&obj->dots[j], cdot, &sx, &sy);
							pts[pi++] = sx;
							pts[pi++] = sy;
	                    }
	            	}//if df
	          	}//for i
	           	DrawPolygon(pts, pi/2, obj->planes[p].color);
	          	drawn = 1;
    	    }//if plane..
    	return;
    }
  #endif //colored

    // here only non polygonal

    if (obj->nplanes<1 || obj->always) {
		for(l=0;l<obj->nlines;l++)
		    obj->lines[l].df=1;
        for(i=0;i<obj->ndots;i++)
   	    	obj->dots[i].df=1;
    } else {

		for(l=0;l<obj->nlines;l++)
			obj->lines[l].df=0;
	    for(i=0;i<obj->ndots;i++)
	       	obj->dots[i].df=0;
			
   		for(p=0;p<obj->nplanes;p++) {
	        t = obj->planes[p].li[0];
	       	t = obj->lines[t].n1;
	        vx = obj->dots[t].ax - MX;
	        vy = obj->dots[t].ay - MY;
	        vz = obj->dots[t].az - MZ;
	        pr = vx * obj->planes[p].nx +
	    	     vy * obj->planes[p].ny +	
	    	     vz * obj->planes[p].nz;
	        if (pr<0) {
	    		for(l=0; l<obj->planes[p].nli; l++) {
           			t = obj->planes[p].li[l];
	    		    obj->lines[ t ].df=1;
			        obj->dots[ obj->lines[t].n1 ].df=1;
    			    obj->dots[ obj->lines[t].n2 ].df=1;
           		}
    	    }
	    }//for p

    }// if always

    DotCalc(obj->dots, obj->ndots);


    for(l=0;l<obj->nlines;l++)
	if (obj->lines[l].df) {

	    n1 = obj->lines[l].n1;

	    n2 = obj->lines[l].n2;
     	dtp = obj->dots[n1].df + obj->dots[n2].df;
      	if (dtp==4) continue;
        if (dtp==2)
		    WDrawLine(obj->dots[n1].cx, obj->dots[n1].cy, 
						obj->dots[n2].cx, obj->dots[n2].cy);
        else {
            if (obj->dots[n1].df==2) {
                bad = n1; good = n2;
            } else {
                bad = n2; good = n1;
            }
   			Intersect(&obj->dots[good], &obj->dots[bad], &sx, &sy);
		    WDrawLine(sx, sy, obj->dots[good].cx, obj->dots[good].cy);
        }
	}
}


typedef struct {
    dbl cx,cy,cz,R, tx,ty,tz;
    Int16 nobj, visible, lockable, vuln;
    Object *obj;
} Group;

void GroupCreate(Group *g, Int32 no)
{
	g->nobj = no; g->lockable=0; g->vuln=0;
	g->obj = (Object*)MemPtrNew(no * sizeof(Object));
 	g->ty=fdbl(-1);
}



void GroupFree(Group *g)
{
	Int16 x;

 	for(x=0;x<g->nobj;x++)
  		ObjectFree(&(g->obj[x]));
    MemPtrFree(g->obj);
}

void GroupDraw(Group *g)

{
	Int16 x;
 	Dot ct;
  	dbl sr;
   	Int32 cr;
  	ct.ax = g->cx; ct.ay = g->cy; ct.az = g->cz; ct.df = 1;
    g->visible=0;
   
	if (Abs(MX - g->cx) > fdbl(5000) || Abs(MZ - g->cz) > fdbl(5000)) return;
   
   	DotCalc(&ct, 1);
    if (ct.rz < - g->R) return;

    else if (ct.rz<=0 && (Abs(ct.rx) + Abs(ct.ry)) > 2*g->R) return;
    if (ct.rz > 0) {
        sr = fdiv(g->R, ct.rz);
        sr = fmul(sr, ScrZ);
        cr = fint(sr);
        if (cr<4) return;
        if (ct.cx + cr<0) return;
        if (ct.cy + cr<0) return;
        if (ct.cx - cr>159) return;
        if (ct.cy - cr>159) return;
    }
        
 	for(x=0;x<g->nobj;x++)
  		ObjectDraw(&(g->obj[x]));
    g->visible=1;
    if (g->lockable && weapon==1 && g->ty>=0 && ltn<0 && gltn==-1) {
      	ct.ax = g->tx; ct.ay = g->ty; ct.az = g->tz; ct.df = 1;
       	DotCalc(&ct, 1);
        //WinDrawLine(ct.cx-5,ct.cy-5,ct.cx+5,ct.cy-5);
        DrawHline(ct.cy-5, ct.cx-5, ct.cx+5, clrCurrent);
        WinDrawLine(ct.cx+5,ct.cy-5,ct.cx+5,ct.cy+5);
        //WinDrawLine(ct.cx-5,ct.cy+5,ct.cx+5,ct.cy+5);
		DrawHline(ct.cy+5, ct.cx-5, ct.cx+5, clrCurrent);
        WinDrawLine(ct.cx-5,ct.cy-5,ct.cx-5,ct.cy+5);
        gltn=-2;
    }
}


typedef struct {
    Group *grp;
    Int16 ngrp;
} World;

void WorldCreate(World *w,Int16 n)
{
	w->ngrp = n;
	w->grp = (Group*)MemPtrNew(n * sizeof(Group));
}

void WorldFree(World *w)
{
	Int16 x;
 	for(x=0;x<w->ngrp;x++)
  		GroupFree(&(w->grp[x]));
	MemPtrFree(w->grp);
}


void WorldDraw(World *w)
{

	Int16 x;
    gltn=-1;
 	for(x=w->ngrp-1;x>=0;x--) {
  		GroupDraw(&(w->grp[x]));
    	if (gltn==-2) gltn = x;
   	}
}

World W;    
Dot *ground;
void DrawGround(dbl *mv, Int16 force) GFX;
void DrawGround(dbl *mv, Int16 force)
{
    Int32 x,y,x0,y0,i;

    if (cTang>fdbl(45)) return;
    
    x0=(fint(MX)/100)*100-600;
    y0=(fint(MZ)/100)*100-600;
    for(y=0;y<12;y++)
	for(x=0;x<12;x++) {
     	i = y*12+x;
	    ground[i].ax = fdbl(x0 + x*100);
	    ground[i].ay = 0;
	    ground[i].az = fdbl(y0 + y*100);
     	if (force ||
      		fmul(ground[i].ax -MX, mv[0]) + fmul(ground[i].ay-MY, mv[1]) + fmul(ground[i].az-MZ,mv[2]) >0)
		    ground[i].df=1;
      	else
       		ground[i].df=0;
	}
    DotCalc(ground, 144);
	for(x=0;x<144;x++)
    	if (ground[x].df && ground[x].cx>=0)
	    	WDrawPixel(ground[x].cx, ground[x].cy);
}

void DrawHorizon(Int16 SY) GFX;
void DrawHorizon(Int16 SY)
{
	dbl t[3],ta[3];
  	dbl y1,y2;
   	Int32 sy1,sy2;
    Int16 skyfirst = 0;
 
    ta[0] = 0; ta[1] = fdbl(200); ta[2] = 0; // ta[3]=fdbl(1);
    MatrVect(R, ta, t);
  	if (Abs(t[2])>38400) {
       	#ifdef COLORED
        if (t[2]>0) DrawLandnSky(0,170,159,170,1,SY);
        else DrawLandnSky(0,-10,159,-10,1,SY);
        #endif
        return;
    }
    if (t[1]>0) skyfirst = 1;
    else if (!t[1] && mKren>0) skyfirst = 1;

    if (t[1]>25600 || t[1]<-25600) { // +- 1/2*200
    	y1 = fmul(t[0], fdbl(80)) - fmul(t[2], ScrZ);
     	y1 = fdiv(y1, t[1]);
    	y2 = fmul(t[0], fdbl(-79)) - fmul(t[2],ScrZ);
     	y2 = fdiv(y2, t[1]);
      	sy1 = 65 - fint(y1) - skyfirst; //-skyfirst is a hack to avoid farms flying
       	sy2 = 65 - fint(y2) - skyfirst;
        //WDrawLine(0,sy1,159,sy2);
        #ifdef COLORED
        DrawLandnSky(0,sy1,159,sy2,skyfirst,SY);
        #else
		WDrawLine(0,sy1,159,sy2);
  		#endif

    } else {
    	y1 = fmul(t[1], fdbl(65)) + fmul(t[2], ScrZ);
     	y1 = fdiv(y1, t[0]);
    	y2 = fmul(t[1], fdbl(-64)) + fmul(t[2],ScrZ);
     	y2 = fdiv(y2, t[0]);
      	sy1 = 80 - fint(y1);
       	sy2 = 80 - fint(y2);
        //WDrawLine(sy1,0,sy2,129);
        #ifdef COLORED
        DrawLandnSky(sy1,0,sy2,SY-1,skyfirst,SY);
        #else
        WDrawLine(sy1,0,sy2,129);
        #endif
    }
}

void CalcRMatr(matr r)
{
    Int16 x,y;
    Int32 mkrs=fint(cKurs)%360, mtng=fint(cTang)%360, mkrn=fint(cKren)%360;

    if (mkrs<0) mkrs+=360;
    if (mkrn<0) mkrn+=360;
    if (mtng<0) mtng+=360;
    
    for(y=0;y<3;y++)
	for(x=0;x<3;x++)
	    Rcrm[y*3+x]=r[y*3+x]=fdbl((x==y));

    r[0*3+0]=cosa[mkrs];
    r[0*3+2]=-sina[mkrs];
    r[2*3+0]=sina[mkrs];
    r[2*3+2]=cosa[mkrs];

    Rcrm[1*3+1]=cosa[mtng];
    Rcrm[1*3+2]=-sina[mtng];
    Rcrm[2*3+1]=sina[mtng];
    Rcrm[2*3+2]=cosa[mtng];
    MatrMul(Rcrm, r);

	for(y=0;y<3;y++)
  	  for(x=0;x<3;x++)
	    Rcrm[y*3+x]=fdbl((x==y));
    Rcrm[0*3+0]=cosa[mkrn];
    Rcrm[0*3+1]=-sina[mkrn];
    Rcrm[1*3+0]=sina[mkrn];
    Rcrm[1*3+1]=cosa[mkrn];
    MatrMul(Rcrm, r);    
}


void CalcR1Matr(matr r, dbl Kurs, dbl Tang, dbl Kren)
{
    Int32 mkrs=fint(-Kurs)%360, mtng=fint(-Tang)%360, mkrn=fint(-Kren)%360,x,y;

    if (mkrs<0) mkrs+=360;
    if (mkrn<0) mkrn+=360;
    if (mtng<0) mtng+=360;
    
    for(y=0;y<3;y++) 
     for(x=0;x<3;x++)
     	Rcrm[y*3+x]=r[y*3+x]=fdbl((y==x));
    r[0*3+0]=cosa[mkrn];
    r[0*3+1]=-sina[mkrn];
    r[1*3+0]=sina[mkrn];
    r[1*3+1]=cosa[mkrn];
    Rcrm[1*3+1]=cosa[mtng];
    Rcrm[1*3+2]=-sina[mtng];
    Rcrm[2*3+1]=sina[mtng];

    Rcrm[2*3+2]=cosa[mtng];
	MatrMul(Rcrm, r);

    for(y=0;y<3;y++) 
     for(x=0;x<3;x++)
     	Rcrm[y*3+x]=fdbl((y==x));
    Rcrm[0*3+0]=cosa[mkrs];
    Rcrm[0*3+2]=-sina[mkrs];
    Rcrm[2*3+0]=sina[mkrs];
    Rcrm[2*3+2]=cosa[mkrs];
    MatrMul(Rcrm, r);
}


Int32 isqrt(Int32 x)
{
	Int32 l,h,t;
 	if (x<=0) return 0;
 	l=0; 
  	if (x>0xFFFF) h = 0xFFFF;
    else h=x;
  	t = h;
  	while(h-l >1) {
       t = (h+l)>>1;
       if (t*t == x) return t;
       if (t*t > x) h = t;
       else l = t;
    }
    return t;
}

Char *screentext;
UInt32 texttick;

void SetText(Char *txt)
{
	screentext = txt;
  	texttick = TimGetTicks();
}


Int16 RocketSend(Int16 state, Int16 tgn, dbl x0, dbl y0, dbl z0);
void Bang(dbl x, dbl y ,dbl z);
void Die() WSEC2;

typedef struct {
    dbl ax,ay,az, vx,vy,vz;
    dbl Kurs, Tang, Kren, crc; // crc = xor of angles
    Int16 state, role, visible, rnum, tgn, H, type; // rnum - number of rockets, tgn - target group name
    UInt32 timetogo;
    dbl tx, ty, tz;
    Object obj, robj; //drawn, rotated
} Fighter;


typedef struct {
    Int32 t0, visible;
    Object obj;
} Boom;

typedef struct {
    dbl ax,ay,az, vx,vy,vz, tx,ty,tz;
    Int16 state, visible, tgn, bad;

    Object obj;
} Rocket;

typedef struct {
    dbl ax,ay,az;
    Int32 timeout, alive;
    Object obj;
} Launcher;

typedef struct {
    dbl ax,ay,az, vx,vy,vz, v;
    Int16 state;
    Object obj;
} Bomb;

typedef struct {
    dbl ax,ay,az;
    Int16 state;
    Object obj;
} Trooper;

Fighter fgt[16];
Object airplane, bigplane, man, trooper, myplane;
Rocket rkt[16];
Boom bms[16];
Launcher lns[32];
Bomb bmb[16];
Trooper trp[16];
Int16 nfgt, nlns;



#include "launcher.c"
#include "world.c"
#include "fighter.c"
#include "rocket.c"

Int16 RocketSend(Int16 state, Int16 tgn, dbl x0, dbl y0, dbl z0) //x if ok, -1 if error
{
 	Int16 x,y;

  	if (viewstate>90) return -1;
   	#ifdef PEACE
   	return -1;
    #endif
  	for(x=0;x<16;x++)
   		if(rkt[x].state==0) {
         	rkt[x].state = state;
          	rkt[x].ax = x0; rkt[x].ay = y0; rkt[x].az = z0;
           	for(y=3;y<8;y++) {
                rkt[x].obj.dots[y].ax = x0;
                rkt[x].obj.dots[y].ay = y0;
                rkt[x].obj.dots[y].az = z0;
            }
            rkt[x].tgn = tgn;
            if ((state>9) && ((bitrand(x0+y0+z0)&63)>42))
	            rkt[x].bad = 1;
            else
            	rkt[x].bad = 0;
         	return x;
        }
    return -1;
}

void Bang(dbl x, dbl y ,dbl z)
{
	Int16 i,n;
 	for(i=0;i<16;i++)
  		if(bms[i].t0==0) {
        	BoomBang(&(bms[i]),x,y,z);
         	if (Abs(x-mx)+Abs(y-my)+Abs(z-mz)>0 && viewstate<90)
         	if (Abs(x-mx)<fdbl(50) && Abs(y-my)<fdbl(50) && Abs(z-mz)<fdbl(50) && (bitrand(x+y+z)&1)) {
          		falling=1; 
            	SetText("You are damaged!");
            }
            for(n=0;n<W.ngrp;n++)
            	if(W.grp[n].vuln && Abs(W.grp[n].cx-x)<fdbl(50) && 
             		Abs(W.grp[n].cy-y)<fdbl(50) && Abs(W.grp[n].cz-z)<fdbl(50))
               			Destroy(n);
            for(n=0;n<nlns;n++)

            	if (lns[n].alive && Abs(lns[n].ax-x)<fdbl(50) &&
             		Abs(lns[n].ay-y)<fdbl(50) && Abs(lns[n].az-z)<fdbl(50))
               			lns[n].alive=0;
         	return;
        }
}

//void DrawBoard() WSEC2;
void DrawBoard()
{
	RectangleType rcbrd, rc;
 	Int32 y;
    rcbrd.topLeft.x=0; rcbrd.topLeft.y=130;
    rcbrd.extent.x=160; rcbrd.extent.y=30;
    WinDrawRectangle(&rcbrd, 0);
    WinEraseChars("HEAD",4,1,132);
    WinEraseChars("ALT",3,7,148);
    WinEraseChars("R",1,104,148);
    WinEraseChars("C",1,134,148);
    WinEraseChars("T",1,99,132);
    showR=1; showT=1; showTh=1;
    rc.topLeft.x=58; rc.topLeft.y=132;
    rc.extent.x=4; rc.extent.y=26;
    WinEraseRectangle(&rc, 0);
    if (Fuel>=0) {
        y = 157 - fint(Fuel)/50;
	    rc.topLeft.x=59; rc.topLeft.y=y;
    	rc.extent.x=2; rc.extent.y=157-y;
    	WinDrawRectangle(&rc, 0);
    }
}

void ShowBoard() WSEC2;
void ShowBoard()
{
	RectangleType rcrad, rc;
 	Int16 i;
  	Int32 x,z,y, krs;
   	dbl v1[3], v2[3];
 
    rcrad.topLeft.x=65; rcrad.topLeft.y=129;
    rcrad.extent.x=30; rcrad.extent.y=30;

    krs = fint(mKurs);
    for(y=0;y<3;y++)
     for(x=0;x<3;x++)
      Msb[y*3+x]=fdbl((x==y));
    Msb[0*3+0]=cosa[krs];
    Msb[0*3+2]=-sina[krs];
    Msb[2*3+0]=sina[krs];
    Msb[2*3+2]=cosa[krs];

    
	WinEraseRectangle(&rcrad, 0);
 	WDrawPixel(80,144);
 	for(i=0;i<nfgt;i++)
	  	if (fgt[i].state>0) {
        	v1[0] = fgt[i].ax - mx; v1[1] = fgt[i].ay - my; v1[2] = fgt[i].az - mz;
         	MatrVect(Msb,v1,v2);
          	x = fint(v2[0])/400; z = fint(v2[2])/400;
           	if (x>-17 && x<17 && z>-17 && z<17)
            	WDrawPixel(80+x, 144-z);
        }

    rc.topLeft.x=25; rc.topLeft.y=132;
    rc.extent.x=22; rc.extent.y=11;
    WinEraseRectangle(&rc, 0);
    outintg(fint(mKurs), rc.topLeft.x, rc.topLeft.y);
    
    rc.topLeft.x=25; rc.topLeft.y=148;
    rc.extent.x=22; rc.extent.y=11;
 	WinEraseRectangle(&rc, 0);
    outintg(fint(my), rc.topLeft.x, rc.topLeft.y);

    if (showR) {
	    rc.topLeft.x=110; rc.topLeft.y=148;
	    rc.extent.x=15; rc.extent.y=11;
	    WinEraseRectangle(&rc, 0);
     	if (weapon==1)
		    outintg(rocketsleft, rc.topLeft.x, rc.topLeft.y);
     	if (weapon==2)
		    outintg(bombsleft, rc.topLeft.x, rc.topLeft.y);

     	showR=0;
	    rc.topLeft.x=104; rc.topLeft.y=148;
	    rc.extent.x=5; rc.extent.y=11;
	    WinDrawRectangle(&rc, 0);
     	if (weapon==1)
        	WinEraseChars("R",1,104,148);
        else 
        	WinEraseChars("B",1,104,148);
    }
    if (showT) {
	    rc.topLeft.x=140; rc.topLeft.y=148;
	    rc.extent.x=15; rc.extent.y=11;
	    WinEraseRectangle(&rc, 0);
	    outintg(traps, rc.topLeft.x, rc.topLeft.y);
     	showT=0;
     }
    if (showTh) {
	    rc.topLeft.x=105; rc.topLeft.y=132;
	    rc.extent.x=15; rc.extent.y=11;
	    WinEraseRectangle(&rc, 0);
	    outintg(fint(maSpeed), rc.topLeft.x, rc.topLeft.y);
     	showTh=0;
     }

    rc.topLeft.x=125; rc.topLeft.y=132;
    rc.extent.x=31; rc.extent.y=11;
    WinEraseRectangle(&rc, 0);

    if (danger)
	    WinDrawChars("DANGER",6, rc.topLeft.x, rc.topLeft.y);	

    if (Fuel>=0) {
     y = 157 - fint(Fuel)/50;
     WinEraseLine(59,y,60,y);
    }
}


void Die()
{
	Bang(mx,my,mz); killed=1;
 	if (viewstate<90)
	 	viewstate=99; //dead 
  	MZ = mz - fdbl(100);
   	MY = my + fdbl(20);
    mKurs =0; mKren=0; mTang=0;
    cKurs =0; cKren=0; cTang=0;
    rcview.extent.y=160;
}

void Intro() WSEC2;
void Intro()
{
	EventType e;
  	RectangleType rc;
   	dbl np[3]={0,0,fdbl(1)};

	DrawOffscreen();
    rc.topLeft.x=65; rc.topLeft.y=139;
    rc.extent.x=30; rc.extent.y=12;
	WinEraseWindow();
 
 	MX = fdbl(50); MY = fdbl(50); MZ = 0;

  	cKurs = cTang = cKren = 0;

   	#ifdef COLORED
    DrawLandnSky(0,65,159,65, 1,160);
    #else
    WinDrawLine(0,65,160,65);
    #endif
 	DrawGround(np,0);
 	WinPaintChars("P A L M   F I G H T E R  1.1",28,41,20);
 	WinPaintChars("by Dmitry Popov",15,49,30);
	WinPaintChars("full version.",13,54,40);
 	WinPaintChars("www.thedeemon.com",17,38,140);

	ShowDrawn();
 	DrawOnscreen();

    do {
      EvtGetEvent (&e, evtWaitForever);
    } while (e.eType!=keyDownEvent && e.eType!=penDownEvent);

}

void ShowBombing(dbl *mv, Int32 dt) WSEC2;
void ShowBombing(dbl *mv, Int32 dt)
{
	dbl t,ax,az,v,vx,vz;
  	Dot ct;
 	
    if (!dt) return;

    if (viewstate==99) return;
   	v = fmul(fdbl(100)/dt,mv[1]);
   	vx = fmul(fdbl(100)/dt,mv[0]);
   	vz = fmul(fdbl(100)/dt,mv[2]);
 	t = isqrt( fint(fmul(v,v)) + 20*fint(my) );
  	t = (v + fdbl(t))/10;
   	ax = mx + fmul(vx,t);
    az = mz + fmul(vz,t);
    
    ct.ax = ax; ct.ay = 0; ct.az = az; ct.df = 1;
    DotCalc(&ct, 1);
    if (ct.cx>-1) {
	    WDrawLine(ct.cx-5,ct.cy-5,ct.cx+5,ct.cy-5);
	    WDrawLine(ct.cx+5,ct.cy-5,ct.cx+5,ct.cy+5);
	    WDrawLine(ct.cx-5,ct.cy+5,ct.cx+5,ct.cy+5);
	    WDrawLine(ct.cx-5,ct.cy-5,ct.cx-5,ct.cy+5);

    }
}

UInt16 usedkeys[8], usedn;

//returns 0 if ok, 1 if penDown
Int16 GetKeypress(UInt16 *ch) WSEC2;
Int16 GetKeypress(UInt16 *ch)
{
 	EventType e;
  	Int16 i;

kstart:
 	do
  		EvtGetEvent(&e, 0);
    while(e.eType!=nilEvent);
    do {
      	EvtGetEvent (&e, evtWaitForever);
      	if (e.eType==penDownEvent)
      		return 1;
    } while(e.eType!=keyDownEvent);
    for(i=0;i<usedn;i++)
    	if (usedkeys[i] == e.data.keyDown.chr)
     		goto kstart;
	usedkeys[usedn++] = e.data.keyDown.chr;
	*ch = e.data.keyDown.chr;
 	return 0;
}

#define KEYDELAY 30

void CustomizeKeys() WSEC2;
void CustomizeKeys()
{
	RectangleType rc;
	Char *s;
 	EventType e;

 	WinEraseWindow();
	WinDrawChars("Up",2,75,10);
	WinDrawChars("Down",4,71,30);
 	WinDrawChars("A",1,30,20);
 	WinDrawChars("B",1,60,20);
 	WinDrawChars("C",1,90,20);
 	WinDrawChars("D",1,120,20);
    rc.topLeft.x=110; rc.topLeft.y=145;
    rc.extent.x=32; rc.extent.y=12;
    WinDrawRectangle(&rc,5);
    WinEraseChars("Cancel",6,113,145);

    do {
      EvtGetEvent (&e, 0);
    } while (e.eType==penDownEvent);

    usedn = 0;
 	s = "Press Up key";
  	WinDrawChars(s,StrLen(s),2,50);
	if (GetKeypress(&keyUp)) return;
 	WinDrawChars("OK",2,140,50);
 	SysTaskDelay(KEYDELAY);
 	s = "Press Down key";
  	WinDrawChars(s,StrLen(s),2,60);
	if (GetKeypress(&keyDown)) return;
 	WinDrawChars("OK",2,140,60);
 	SysTaskDelay(KEYDELAY);
 	s = "Press A key (shift)";
  	WinDrawChars(s,StrLen(s),2,70);
	if (GetKeypress(&keyA)) return;
 	WinDrawChars("OK",2,140,70);
 	SysTaskDelay(KEYDELAY);
 	s = "Press B key (left)";
  	WinDrawChars(s,StrLen(s),2,80);

	if (GetKeypress(&keyB)) return;
 	WinDrawChars("OK",2,140,80);
 	SysTaskDelay(KEYDELAY);
 	s = "Press C key (right)";
  	WinDrawChars(s,StrLen(s),2,90);
	if (GetKeypress(&keyC)) return;
 	WinDrawChars("OK",2,140,90);
 	SysTaskDelay(KEYDELAY);
 	s = "Press D key (fire)";
  	WinDrawChars(s,StrLen(s),2,100);
	if (GetKeypress(&keyD)) return;
 	WinDrawChars("OK",2,140,100);
}

void ShowControls() WSEC2;
void ShowControls()
{
	RectangleType rc;
	Char *s;
 	EventType e;

 	WinEraseWindow();

	WinDrawChars("Up",2,75,10);
	WinDrawChars("Down",4,71,30);

 	WinDrawChars("A",1,30,20);
 	WinDrawChars("B",1,60,20);
 	WinDrawChars("C",1,90,20);

 	WinDrawChars("D",1,120,20);
 	s = "Up/Down -rotate down/up";
  	WinDrawChars(s,StrLen(s),2,50);
 	s = "B/C - rotate left/right";
  	WinDrawChars(s,StrLen(s),2,60);
 	s = "D - launch a missile/chaff";
  	WinDrawChars(s,StrLen(s),2,70);

 	s = "AA - map";
  	WinDrawChars(s,StrLen(s),2,80);
 	s = "AB - eject";
  	WinDrawChars(s,StrLen(s),2,90);

 	s = "AC - change view";
  	WinDrawChars(s,StrLen(s),2,100);

 	s = "AD - change weapon";
  	WinDrawChars(s,StrLen(s),2,110);
 	s = "AUp - increase throttle";
  	WinDrawChars(s,StrLen(s),2,120);
 	s = "ADown - decrease throttle";
  	WinDrawChars(s,StrLen(s),2,130);

    rc.topLeft.x=130; rc.topLeft.y=145;
    rc.extent.x=20; rc.extent.y=12;
    WinDrawRectangle(&rc,5);
    WinEraseChars("OK",2,133,145);

    rc.topLeft.x=10; rc.topLeft.y=145;
    rc.extent.x=70; rc.extent.y=12;
    WinDrawRectangle(&rc,5);
    WinEraseChars("Customize keys",14,13,145);


    do {
      EvtGetEvent (&e, evtWaitForever);
    } while (e.eType==penDownEvent);


    do {
      EvtGetEvent (&e, evtWaitForever);
    } while (e.eType!=penDownEvent);


    if (e.screenX<80 && e.screenY>140) {
    	CustomizeKeys();
     	ShowControls();
    }
}


UInt32
PilotMain (UInt16 cmd, void *params, UInt16 flags) {

  if (cmd == sysAppLaunchCmdNormalLaunch) {
    EventType e,e0;
    dbl dx,dy, mv[3], mv0[3], fSpeed, PS,napr[3],Up[3],Rite[3],dv[3],v,vflow,vflow0;
    Int32 x, krn, frame;
    dbl pi, cnapr[3], cv[3], cv0[3], g, dvy3, mvn[3], mvs[3];
    RectangleType mrc, trc;
    Char *s;
    UInt16 msn[10], handled;
    UInt32 tick0, tick, dt, dt0;
    WinDrawOperation old_oper;
    UInt8 col;

    //prepare  -    one time init
    mrc.topLeft.x=1; mrc.topLeft.y=0;
    mrc.extent.x=90; mrc.extent.y=12;

    TPS = SysTicksPerSecond();
    
    if (GraphicsMode()) {
        #ifdef COLORED
        ErrAlertCustom(0,"Can't switch to 160x160 8bpp color mode.",NULL,NULL);
        #else
        ErrAlertCustom(0,"Can't switch to 160x160 1bpp b/w mode.",NULL,NULL);
        #endif
    	return 0;
    }
    InitScreens();

    ground = (Dot*)MemPtrNew(144*sizeof(Dot));

    pi = 804;
    for(x=0;x<360;x++) {
		if (x<=180) sina[x] = Sin( fdiv(fmul(fdbl(x),pi),fdbl(180)) );
		else sina[x]=-sina[360-x];
    }
    sina[0]=0; sina[90]=fdbl(1); sina[180]=0; sina[270]=fdbl(-1);
    
    for(x=0;x<360;x++)
	 if (x<270)
	    cosa[x] = sina[x+90];
	else
	    cosa[x] = sina[x-270];
    MatrNewE(&R);
    MatrNewE(&R1);
    MatrNewE(&cR1);
    MatrNewE(&Rt);
  	MatrNewE(&Rcrm);  
  	MatrNewE(&Msb);  
    RotSpeedy=640; //  rotate up/down by 2,5 degrees

    ObjectAirplane(&airplane);
    ObjectAirplane(&myplane);
    ObjectBigAirplane(&bigplane);
    ObjectLauncher(&man);
    ObjectTrooper(&trooper);
    tick = TimGetTicks();
    for(x=0;x<16;x++) {
        FighterInit(&(fgt[x]));
        fgt[x].role = x/2;
        fgt[x].timetogo = tick + x*1000;
        ObjectCopy(&(fgt[x].obj), &airplane);
        ObjectCopy(&(fgt[x].robj), &airplane);
    }
    for(x=0;x<32;x++)
    	LauncherInit(&(lns[x]));
    nlns = 0;   

    for(x=0;x<16;x++) {
    	RocketInit(&(rkt[x]));
     	BoomInit(&(bms[x]));
      	BombInit(&(bmb[x]));
       	TrooperInit(&(trp[x]));
    }
    rcview.topLeft.x=0; rcview.topLeft.y=0;
    rcview.extent.x=160; rcview.extent.y=160;

    old_oper = WinSetDrawMode(winOverlay);
    Intro();

    LoadData(1);

l1:    //menu
	WinEraseWindow();
	WinDrawChars("Select mission:",15,20,0);    

	for(x=1;x<10;x++) {
     	mrc.topLeft.y=x*16;
      	WinDrawRectangle(&mrc,5);
    }

    trc.topLeft.x=120; trc.topLeft.y=120;
    trc.extent.x=40; trc.extent.y=12;
    WinDrawRectangle(&trc,5);
    WinEraseChars("Controls",8,123,120);

    trc.topLeft.x=120; trc.topLeft.y=140;
    trc.extent.x=40; trc.extent.y=12;
    WinDrawRectangle(&trc,5);
    WinEraseChars("Exit",4,133,140);
    WinDrawLine(100,0,100,160);

    s = "Oil derrick"; 	msn[2]=1;
    WinEraseChars(s,StrLen(s),10,2*16);
    s = "Trucks";      	msn[3]=3;
    WinEraseChars(s,StrLen(s),10,3*16);
    s = "Convoy";		msn[4]=4;
    WinEraseChars(s,StrLen(s),10,4*16);
    s = "Break on through"; msn[5]=5;
    WinEraseChars(s,StrLen(s),10,5*16);
    s = "Terrorists";   msn[6]=6;
    WinEraseChars(s,StrLen(s),10,6*16);
    s = "Paratroopers"; msn[7]=7;
    WinEraseChars(s,StrLen(s),10,7*16);
    s = "Landing op.";	msn[8]=9;
    WinEraseChars(s,StrLen(s),10,8*16);
    s = "First fight"; 	msn[1]=2;
    WinEraseChars(s,StrLen(s),10,1*16);
    s = "Instant action"; msn[9]=8;
    WinEraseChars(s,StrLen(s),10,9*16);

    do {
      EvtGetEvent (&e, evtWaitForever);
    } while (e.eType==penDownEvent);
    
    do {
	    do {
	      EvtGetEvent (&e, evtWaitForever);
	    } while (e.eType!=penDownEvent);
     	if (e.screenX<90)
		    x = e.screenY/16;
      	else x = 0;
     	if (e.screenX>120 && e.screenY>120 && e.screenY<130) {
          	ShowControls();
           	goto l1;
        }
     	if ((e.screenX>120 && e.screenY>140) || e.screenY>159) goto l17;
    } while(x<1 || x>9);
    mission=msn[x];
    
        // mission init

    ltn = -1; ltx=lty=-1; ltd=100;
    
    frame=0; viewstate=0; inair=0; maSpeed=0; wmaSpeed=0; Fuel=fdbl(1200);
    weapon=1; rocketsleft=20; bombsleft=15;
    traps = 25; danger=0; falling=0;
    texttick=-2000; Shift=0; troopsout=0;
    mcomplete=0; ejected=0; killed=0; failed=0;
    for(x=0;x<16;x++) {
        rkt[x].state=trp[x].state=fgt[x].state=bmb[x].state=bms[x].t0=0;
    }
    MakeWorld(&W);
    tick = TimGetTicks();
    rcview.topLeft.x=0; rcview.topLeft.y=0;    
    rcview.extent.x=160; rcview.extent.y=130;
    cKurs=cKren=cTang=0;
                         
	MissionBrief(&W);  

    DrawBoard();
    ShowBoard();
    DrawOffscreen();

    for(x=0;x<3;x++) {
        mvn[x]=mvs[x]=mv[x]=dv[x]=0;
    }
    tick0=TimGetTicks();     vflow=0; dt=10;
    for(x=0;x<nfgt;x++)
    	fgt[x].timetogo += tick0 - tick;
     
     

    do { //						 MAIN LOOP
        CalcR1Matr(R1, mKurs,mTang,mKren);
        CalcR1Matr(cR1, cKurs,cTang,cKren);
        dt0 = dt;
        #ifdef EMULATING
        SysTaskDelay(3);
        dt = 4;
        tick = TimGetTicks();
        #else
        tick = TimGetTicks();
        dt = tick - tick0;
        if (dt<4) {
            SysTaskDelay(4-dt);
            tick = TimGetTicks();
            dt = tick - tick0;
        }
        #endif

        if (tick/1000 != tick0/1000) {
        	for(x=0;x<nfgt;x++)
        		fgt[x].H = (bitrand(tick + x*0xAA1) & 7) +1;
          	MissionZrk(&W);
        }
        tick0=tick;

        //								MOVING
        if (wmaSpeed > maSpeed) { maSpeed+=fdbl(1); showTh=1; }
        if (wmaSpeed < maSpeed) { maSpeed-=fdbl(1); showTh=1; }

        if (Fuel<=0) {
            if (maSpeed>fdbl(10)) {
                mvs[0]+=mvn[0]; mvs[1]+=mvn[1]; mvs[2]+=mvn[2];
            }
            showTh=1;
            Fuel=0;
            wmaSpeed=maSpeed=0;
        }
        mSpeed = maSpeed*dt/100;
        fSpeed = fdbl(dt); // same shit
        Fuel -= mSpeed/100;
        
        v = isqrt(mv[0]*mv[0] + mv[1]*mv[1] + mv[2]*mv[2]);
        mv0[0]=0; mv0[1]=0; mv0[2]=fdbl(10); //10 is for low error
        
        MatrVect(R1, mv0, napr);

        mv0[0]=0; mv0[1]=fdbl(10); mv0[2]=0;
        MatrVect(R1, mv0, Up);

        mv0[0]=fdbl(10); mv0[1]=0; mv0[2]=0;
        MatrVect(R1, mv0, Rite);
        mv0[0]=0; mv0[1]=0; mv0[2]=fdbl(10); //10 is for low error
        MatrVect(cR1, mv0, cnapr);
        
        PS = (fmul(mv[0],napr[0]) + fmul(mv[1],napr[1]) + fmul(mv[2],napr[2]))/100;
        vflow0=vflow;
       	vflow = fmul(napr[1],v)/10 - mv[1];
        
        mvn[0]=fmul(napr[0],mSpeed)/10;
        mvn[1]=fmul(napr[1],mSpeed)/10;
        mvn[2]=fmul(napr[2],mSpeed)/10;
        
        dv[0]=fmul(Up[0], PS)/10;
        dv[1]=dvy3=fmul(Up[1], PS)/10;
        dv[2]=fmul(Up[2], PS)/10;
        g = fdbl(10)*dt/100;
	    dv[1]-=g; //mg
        if (dv[0]<fdbl(-2)) dv[0]=fdbl(-2);
        if (dv[0]>fdbl(2)) dv[0]=fdbl(2);
        if (dv[1]<fdbl(-2)) dv[1]=fdbl(-2);
        if (dv[1]>fdbl(2)) dv[1]=fdbl(2);
        if (dv[2]<fdbl(-2)) dv[2]=fdbl(-2);
        if (dv[2]>fdbl(2)) dv[2]=fdbl(2);
         
        //if (inair)
        mvs[0]+=dv[0]; mvs[1]+=dv[1]; mvs[2]+=dv[2];
        mv[0]=mvn[0]+mvs[0]; mv[1]=mvn[1]+mvs[1]; mv[2]=mvn[2]+mvs[2];
        if (maSpeed>0) {
            mvs[0]=mvs[1]=mvs[2]=0;
        } else {
            dx = fdbl(dt);// 100m/s
            if (mvs[0]<-dx) mvs[0]=-dx;
            if (mvs[0]>dx) mvs[0]=dx;
            if (mvs[1]<-dx) mvs[1]=-dx;
            if (mvs[1]>dx) mvs[1]=dx;
            if (mvs[2]<-dx) mvs[2]=-dx;
            if (mvs[2]>dx) mvs[2]=dx;
        }

        if (my<=fdbl(2) && viewstate<90) {
            if (inair) {
	            my = 0;
    	        SetText("You crashed!"); killed=2;
        	    Die();
            } else 
            if (mv[1]<=0) {
              mv[1]=mvs[0]=0;
              my=fdbl(2);
            }
        }
        if (my<=fdbl(2) && viewstate==93) {
	            my = 0;
             	Bang(mx,my,mz);
              	mx=my=mz=fdbl(20000);
        }
        
        if (viewstate<99) {
	        mx+=mv[0]; my+=mv[1]; mz+=mv[2];
         	if (mx<fdbl(-7000)) mx+=fdbl(100);
         	if (mx>fdbl(13000)) mx-=fdbl(100);
         	if (mz<fdbl(-4000)) mz+=fdbl(100);
         	if (mz>fdbl(16000)) mz-=fdbl(100);
          	if (my>fdbl(3000)) my = fdbl(3000);
            if (my>fdbl(3)) inair=1;
         }
        
        if (viewstate==0) {
            MX=mx; MY=my; MZ=mz;
        }
        if (viewstate==93) {
            MX = trp[0].ax; MY=trp[0].ay+ fdbl(8); MZ = trp[0].az - fdbl(20);
            cKurs=0; cKren=0; cTang=0;
		}
  		if (viewstate==1) {
        	MX = mx - cnapr[0]*3; MY = my - cnapr[1]*3/2; MZ = mz - cnapr[2]*3;
        }

  		//							ACTING
		for(x=0;x<nfgt;x++)
  			if (fgt[x].state>0) {
         		if (((x/2)%4) == (frame%4))
           			FighterThink(&(fgt[x]));
              	if (fgt[x].type==0) {
	         		fgt[x].ax += fmul(fgt[x].vx, fSpeed);
	         		fgt[x].ay += fmul(fgt[x].vy, fSpeed);
	         		fgt[x].az += fmul(fgt[x].vz, fSpeed);
            	} else
             	if (fgt[x].type==1) {
                  	fSpeed = fmul(fSpeed, 192);
	         		fgt[x].ax += fmul(fgt[x].vx, fSpeed);
	         		fgt[x].ay += fmul(fgt[x].vy, fSpeed);
	         		fgt[x].az += fmul(fgt[x].vz, fSpeed);
            		fSpeed = fdbl(dt);

                }
         	} else //state>0
          	if (fgt[x].state==-9 && tick >= fgt[x].timetogo)
           		fgt[x].state = 1;
        danger=0;
        for(x=0;x<16;x++) {
        	if (rkt[x].state>0) 
    			RocketFly(&(rkt[x]),dt);	        
         	if (bms[x].t0) 
          		BoomGo(&(bms[x]),tick);
            if (bmb[x].state)
            	BombFall(&(bmb[x]),dt);
            if (trp[x].state)
            	TrooperFall(&(trp[x]),dt);
         }
        frame++;
        for(x=0;x<nlns;x++)
           	if (lns[x].timeout >0)
           		lns[x].timeout-=dt;
        	else
      		if (lns[x].alive && Abs(lns[x].ax - mx) < fdbl(2000) && Abs(lns[x].az - mz) < fdbl(2000)) 
                	LauncherFire(&(lns[x]));
            
		MissionAct(&W, tick);        
        CalcRMatr(R);
        
        // 									  DRAWING
		//
  		#ifndef COLORED
  		WinEraseRectangle(&rcview,0);
    	#endif
  		DrawHorizon(rcview.extent.y);

    	#ifdef FPS
        outintg(dt,0,0);
        #endif

        if (Shift) WinPaintChars("Shift",5,0,120);
		if (tick >= texttick && tick < texttick + 500)
  			WinPaintChars(screentext, StrLen(screentext), 2, 30);
		

        DrawGround(cnapr,0);
    	WorldDraw(&W);
     	for(x=0;x<nlns;x++)
      		if (lns[x].alive && Abs(lns[x].ax - MX) < fdbl(800) && Abs(lns[x].az - MZ) < fdbl(800))
        		ObjectDraw(&(lns[x].obj));
    	DrawFighters();

     	for(x=0;x<16;x++) {
			if (rkt[x].visible && rkt[x].state)
				RocketDraw(&(rkt[x]));
    		col = WSetForeColor(clrFire);
    		if (bms[x].t0 && bms[x].visible) 
      			ObjectDraw(&(bms[x].obj));
            WSetForeColor(col);
    	}
     	DrawBombs();
      	if (weapon==2)
       		ShowBombing(mv, dt);
        if (viewstate==1 || viewstate==2 || viewstate==93) {
            for(x=0;x<myplane.ndots;x++) {
                cv0[0] = airplane.dots[x].ax;
                cv0[1] = airplane.dots[x].ay;
                cv0[2] = airplane.dots[x].az;
                MatrVect(R1,cv0,cv);
                myplane.dots[x].ax = mx + cv[0];
                myplane.dots[x].ay = my + cv[1];
                myplane.dots[x].az = mz + cv[2];
            }
            ObjectDraw(&myplane);
        }
     	
		for(x=0;x<16;x++) {
         	if (trp[x].state && Abs(trp[x].ax - MX)<fdbl(1500) && Abs(trp[x].az - MZ)<fdbl(1500))
          		ObjectDraw(&(trp[x].obj));
    	}


     	if (viewstate==0) {
            DrawHline(129,55,64,255);
            DrawHline(129,95,104,255);
            DrawHline(128,56,103,255);
            DrawHline(127,57,102,255);
       }
      
        ShowDrawn();
     	if (viewstate==0) {
            DrawOnscreen();
	    	ShowBoard();
            DrawOffscreen();
      	}

       	//								CONTROL
        EvtGetEvent (&e, 0);
        do {
		    EvtGetEvent (&e0, 0);
      		if (e0.eType == penDownEvent) {
            	MemMove(&e, &e0, sizeof(e));
             	break;
            }
            if (e0.eType != keyDownEvent)
            	SysHandleEvent(&e0);
      	} while(e0.eType != nilEvent);
     	handled = 0;
     	if (e.eType==winExitEvent) break;
     	if (e.eType==keyDownEvent && viewstate<90) {
        	if (e.data.keyDown.chr == keyUp) {
         		if (!Shift) {
             		krn = fint(mKren);
	              	krn = krn%360; if (krn<0) krn+=360;
	             	dx = fmul(sina[krn], RotSpeedy);
	              	dy = fmul(cosa[krn], RotSpeedy);
	               	mKurs -= dx; mTang -= dy;
    	       	} else {
                	if (wmaSpeed<=fdbl(175))
	                	wmaSpeed+=fdbl(25);
    	            Shift=0; showTh=1;
       	    	}
             	handled = 1;
            }
         	if (e.data.keyDown.chr == keyDown){
              	if (!Shift) {
             		krn = fint(mKren);
	              	krn = krn%360; if (krn<0) krn+=360;
	             	dx = fmul(sina[krn], RotSpeedy);
	              	dy = fmul(cosa[krn], RotSpeedy);
	               	mKurs += dx; mTang += dy;
              	} else {
    	            Shift=0; showTh=1;
	                if (wmaSpeed>=fdbl(25))
                		wmaSpeed-=fdbl(25);
              	}
              	handled = 1;
            }
        	if (e.data.keyDown.chr == keyB && inair) {
             	if (!Shift)
		   	      	mKren-=fdbl(5);
           		else 
             	if (my>fdbl(15)) {
                 	TrooperSet(&(trp[0]),mx,my-fdbl(10),mz);
                  	viewstate=93; Shift=0; rcview.extent.y=160; falling=1; ejected=1;
                }
                handled = 1;
         	}
         	if (e.data.keyDown.chr == keyC && inair) {
              if (Shift) {
                  viewstate = (viewstate+1)%3;
                  Shift=0; 
                  switch(viewstate) {
                      case 0:
                      	rcview.extent.y=130;
                        DrawOnscreen();
        		       	DrawBoard();
                        DrawOffscreen();
                      break;
                      case 1:
                      	rcview.extent.y=160;
                      break;
                      case 2:
                      	rcview.extent.y=160;
                       	MX=mx; MZ=mz; MY=fdbl(50);
                        cKren=0; cTang=fdbl(20); cKurs=mKurs;
                      break;
                  }
              } else
		          mKren+=fdbl(5);
              handled = 1;
            }
            if (e.data.keyDown.chr == keyA) {
                if (Shift) {
                    DrawOnscreen();
    	            ShowMap(&W);
        	        DrawBoard();
                    DrawOffscreen();
	                tick0=TimGetTicks()-dt; Shift=0;
                } else {
                    Shift=1;
                }
              	handled = 1;
            }
           	if (e.data.keyDown.chr == keyD) {
              if (!Shift) {
                if (danger && traps>0) { //throw out trap
                	for(x=0;x<16;x++)
                 		if (rkt[x].state==3) rkt[x].state=4;
                   traps--; showT=1;
                } else
                if (weapon==1 && rocketsleft>0 && ltn>-1) {
                    RocketSend(ltn+10,-1, mx, my - fdbl(5), mz);
                   	rocketsleft--; showR=1;
                } else
                if (weapon==1 && rocketsleft>0 && gltn>-1) {
                    x=RocketSend(1,gltn, mx, my - fdbl(5), mz);

                    rkt[x].tx = W.grp[gltn].tx; rkt[x].ty = W.grp[gltn].ty; rkt[x].tz = W.grp[gltn].tz;
                   	rocketsleft--; showR=1;

                } else
                if (weapon==2 && bombsleft>0) {
                    for(x=0;x<16;x++)
                    	if (!bmb[x].state) break;
                    BombLaunch(&(bmb[x]),mx,my-fdbl(2),mz, mv);
                    bombsleft--; showR=1;
                }
              } else {
                  if (weapon==1) weapon=2;
                  else weapon=1; showR=1;

                  Shift=0;
              }
              handled = 1;
            }
            #ifdef EMULATING
           	if (e.data.keyDown.chr == vchrHardPower || e.data.keyDown.chr == vchrPowerOff) {
            	EvtGetEvent (&e, 1000);
              	handled = 1;
            }
            #endif

        } //if (e.eType==keyDownEvent && viewstate<90) {
        if (!handled)
	        SysHandleEvent(&e);

       	krn = fint(mKren);
       	krn = krn%360; if (krn<0) krn+=360;

       	dx = sina[krn];
        if (vflow*vflow0 >0) dy = -vflow/4;
        else dy = 0;
        //dy = (cosa[krn]-fdbl(1))/2;
       	mKurs += dx; mTang += dy;
      	if (falling) {
           if (mTang > fdbl(-80))
	           mTang -= 128;
           mKren += fdbl(10);
        }
              
        if (mTang>fdbl(90)) {
            mTang = fdbl(180) - mTang;
            mKurs += fdbl(180);
            mKren += fdbl(180);
        }
        if (mTang<fdbl(-90)) {
            mTang = fdbl(-180) - mTang;
            mKurs += fdbl(180);
            mKren += fdbl(180);
        }
       	while(mKren<fdbl(-180)) mKren+=fdbl(360);
      	while(mKren>=fdbl(180)) mKren-=fdbl(360);

      	while(mKurs<0) mKurs+=fdbl(360);
      	while(mKurs>=fdbl(360)) mKurs-=fdbl(360);
       
       	if (viewstate==0 || viewstate==1) {
            cKurs=mKurs; cKren=mKren; cTang=mTang;
        }
    } while (e.eType!=appStopEvent && e.eType!=penDownEvent);

    if (e.eType == penDownEvent && e.screenY>159) { //tap on silk screen: exit
    	WorldFree(&W);
     	goto l17;
    }
    DrawOnscreen();
    MissionScore(&W);
    WorldFree(&W);
    goto l1;
    
l17:
	SaveData(0);

    for(x=0;x<32;x++)
    	LauncherFree(&(lns[x]));

    for(x=0;x<16;x++) {
        FighterFree(&(fgt[x]));
    	RocketFree(&(rkt[x]));
     	BoomFree(&(bms[x]));
      	BombFree(&(bmb[x]));
       	TrooperFree(&(trp[x]));
     }
    MatrFree(R);
    MatrFree(R1);
    MatrFree(cR1);
    MatrFree(Rt);
    MatrFree(Rcrm);
    MatrFree(Msb);
    ObjectFree(&airplane);
    ObjectFree(&bigplane);
    ObjectFree(&man);
    ObjectFree(&trooper);
    ObjectFree(&myplane);
    MemPtrFree(ground);
    WinSetDrawMode(old_oper);
    EndScreens();
    RestoreMode();
            /*
	do
	   	EvtGetEvent (&e, 50);
    while(e.eType!=penDownEvent);*/
  }           

  return 0;
}

